VERSION 5.00
Begin VB.UserControl Axis 
   AutoRedraw      =   -1  'True
   ClientHeight    =   735
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3405
   ClipControls    =   0   'False
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   12
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   49
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   227
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   600
      Top             =   240
   End
   Begin VB.Shape shpZoomArea 
      BackColor       =   &H80000000&
      BorderStyle     =   3  'Dot
      Height          =   495
      Left            =   1020
      Top             =   120
      Visible         =   0   'False
      Width           =   1215
   End
End
Attribute VB_Name = "Axis"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'==================================================================================================================
' Description.....: ActiveX to manage rappresentation of shapes on video
' File Name.......: Axis2.ctl
' Data............: 13/11/2003
' Version.........: 1.0(32 bit).
' System..........: VB6,Windows 98.
' Written by......: Condor trade s.r.l.
' E-Mail..........: info@condorgroup.com
' web Site........: http://www.inblu.com
'==================================================================================================================

Option Explicit

'Graphical API

'Draw a series of straight lines
'***********************************************************************
'ATTENTION:This function doesn't draw last point of array structure and
'is unsensible to scale direction changing
'***********************************************************************
Private Declare Function PolylineTo Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Private Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long
Private Declare Function SelectObject Lib "gdi32.dll" (ByVal hdc As Long, ByVal hObject As Long) As Long

'Put cursor in the specified position
Private Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpPoint As Any) As Long

Private Type Rect
    
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
    
End Type

Private Type POINTAPI
    X As Long
    Y As Long
End Type

Private Type D_AREA

    Left As Double
    Top As Double
    Width As Double
    Height As Double
    
End Type

'Enumeration used to indicate the style
'of rappresentation of shape
Public Enum Style

    Marker = 0
    Lines
    MarkerAndLines
    Spline
    SplineAndMarker

End Enum


Private Type DrawShape

    X() As Double
    Y() As Double
    Z() As Double
    Colour() As Long
    OPtsPointer() As Long
    Marker() As String
    MarkerSize() As Long
    
End Type

Private Type DrawSolid

    DShapes() As DrawShape

End Type

Public Enum PlaneType

    NoPlane = 0
    xy = 1
    xz = 2
    yz = 3
    XYZ = 4

End Enum

Public Enum SelectAction

    Deselection = 0
    Selection
    
End Enum

Public Enum Functions

    NoType = 0
    PointType
    ShapesType
    SolidType
    MultiPointType
    MultiShapeType
    MultiSolidType
    
End Enum

Public Enum Applications

    Graphic = 0
    Painting
    Colata
    Cutting
    
End Enum

Private Type FindOnScreen
    
    TypeID As Functions
    SolidID As Long
    ShapeID As Long
    PointID As Long
    Dist As Double
        
End Type

Private DrawingArea As D_AREA

'TEST
Public SpinScreenXSAngle As Double


'Valori predefiniti propriet:
Const m_def_Applications = 0
Const m_def_ScaledMouseY = 0
Const m_def_ScaledMouseX = 0
Const m_def_FixedScale = 0
Const m_def_LabelXAxis = " X"
Const m_def_LabelYAxis = " Y"
Const m_def_LabelZAxis = " Z"
Const m_def_FigureTitle = " "
Const m_def_XStepGrid = 30
Const m_def_YStepGrid = 30
Const m_def_ZStepGrid = 30
Const m_def_OBorderLeft = 70
Const m_def_OBorderRight = 70
Const m_def_OBorderTop = 70
Const m_def_Grid = 0
Const m_def_OBorderBottom = 70
Const m_def_Saved = 0
Const m_def_XCenter = 0
Const m_def_YCenter = 0
Const m_def_ZCenter = 0
Const m_def_SpinScreenXAngle = 0
Const m_def_SpinScreenYAngle = 0
Const m_def_Plane = 0
Const m_def_NumberOfSolid = 0
Const m_def_Hold = 0
Const m_def_Selected = 0
Const m_def_Zoomed = 0
Const m_def_UnZoomed = 0
Const m_def_BorderFactor = 1.2
Const m_def_MousePointer = 0

Private mSolids As Collection
Private mApplications As Collection

Private ArraySolids() As DrawSolid

'Local variable for manual scale setting
Private m_ActiveMScale As Boolean

'Local variable to convert robot speed in a valid
'color
Private EncSpeedColor As Long

'Local variables for shape moving
Private tmpDiffX As Double
Private tmpDiffY As Double

'Local variables for zoom
Private OX As Long
Private OY As Long
Private ZoomProcedure As Boolean

'Local variables for mouse coordinates
Private SelectedObject() As FindOnScreen
Private MinMouseX As Double
Private MinMouseY As Double
Private tmpZoomExcursionX As Double, tmpX1 As Double, tmpX2 As Double
Private tmpZoomExcursionY As Double, tmpY1 As Double, tmpY2 As Double
Private tmpZoomMinX As Double
Private tmpZoomMinY As Double
Private SF As Double, m_ManualScale As Double, PrevSF As Double


'Local variable for moving
Private m_MoveDeltaSelected As Boolean
Private m_MoveTo As Boolean
Private Delay As Boolean
Private m_ActiveMoveDelta As Boolean
Private m_ActiveMoveTo As Boolean

'Local variables to add and remove
'objects from collection
Private m_AddExternalPoint As Boolean
Private m_AddPointOnEdge As Boolean
Private InsertPoint As Long
Private SelectedFirstPoint As FindOnScreen
Private SelectedSecondPoint As FindOnScreen
Private tmpAddExtPntSolid As New InBlu_Solid
Private tmpAddExtPntShape As New InBlu_Shape_3D
Private tmpAddExtPntPoint As New InBlu_Point_3D

Private WithEvents mFont As StdFont
Attribute mFont.VB_VarHelpID = -1

'Property variables:
Private m_MouseIcon As Picture
Private m_MousePointer As MousePointerConstants
Private m_Applications As Applications
Private m_ScaledMouseY As Double
Private m_ScaledMouseX As Double
Private m_BorderFactor As Double
Private m_UnZoomed As Boolean
Private m_FixedScale As Boolean
Private m_LabelXAxis As String
Private m_LabelYAxis As String
Private m_LabelZAxis As String
Private m_FigureTitle As String
Private m_XStepGrid As Double
Private m_YStepGrid As Double
Private m_ZStepGrid As Double
Private m_OBorderLeft As Double
Private m_OBorderRight As Double
Private m_OBorderTop As Double
Private m_OBorderBottom As Double
Private m_Grid As Boolean
Private m_Saved As Boolean
Private m_XCenter As Double
Private m_YCenter As Double
Private m_ZCenter As Double
Private m_SpinScreenXAngle As Double
Private m_SpinScreenYAngle As Double
Private m_Plane As String
Private m_NumberOfSolid As Boolean
Private m_Hold As Boolean
Private m_Selected As Boolean
Private m_Zoomed As Boolean
Private m_SelectEntity As Functions
Private m_BackColor As OLE_COLOR
Private m_ChangeRappresentation As Style
Private m_ExternalScale As Double

'Dichiarazioni di eventi:
Event Click() 'MappingInfo=UserControl,UserControl,-1,Click
Attribute Click.VB_Description = "Viene generato quando si preme e quindi si rilascia un pulsante del mouse su un oggetto."
Event DblClick() 'MappingInfo=UserControl,UserControl,-1,DblClick
Attribute DblClick.VB_Description = "Viene generato quando si preme e si rilascia due volte in rapida successione un pulsante del mouse su un oggetto."
Event KeyDown(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyDown
Attribute KeyDown.VB_Description = "Viene generato quando si preme un tasto mentre lo stato attivo si trova su un oggetto."
Event KeyPress(KeyAscii As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyPress
Attribute KeyPress.VB_Description = "Viene generato quando si preme e si rilascia un tasto ANSI."
Event KeyUp(KeyCode As Integer, Shift As Integer) 'MappingInfo=UserControl,UserControl,-1,KeyUp
Attribute KeyUp.VB_Description = "Viene generato quando si rilascia un tasto mentre lo stato attivo si trova su un oggetto."
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseDown
Attribute MouseDown.VB_Description = "Viene generato quando si preme il pulsante del mouse mentre lo stato attivo si trova su un oggetto."
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseMove
Attribute MouseMove.VB_Description = "Viene generato quando si sposta il mouse."
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single) 'MappingInfo=UserControl,UserControl,-1,MouseUp
Attribute MouseUp.VB_Description = "Viene generato quando si rilascia il pulsante del mouse mentre lo stato attivo si trova su un oggetto."
Event Hide() 'MappingInfo=UserControl,UserControl,-1,Hide
Attribute Hide.VB_Description = "Viene generato quando la propriet Visible del controllo viene impostata su False."
Event Paint() 'MappingInfo=UserControl,UserControl,-1,Paint
Attribute Paint.VB_Description = "Viene generato quando una parte qualsiasi di un form o di un controllo PictureBox viene spostata, allargata o esposta."
Event Resize() 'MappingInfo=UserControl,UserControl,-1,Resize
Attribute Resize.VB_Description = "Viene generato non appena un form viene visualizzato o quando le dimensioni di un oggetto vengono modificate."
Event Show() 'MappingInfo=UserControl,UserControl,-1,Show
Attribute Show.VB_Description = "Viene generato quando la propriet Visible del controllo viene impostata su True."
Event Selected(SolidsSelected() As Long, ShapesSelected() As Long, PointsSelected() As Long, Types() As Functions, Actions As SelectAction)
Event LineOnForm(X As Single, Y As Single)
Event PointAdded(ByVal IndexOfSolid As Long, ByVal IndexOfShape As Long, ByVal IndexOfPoint As Long)
Event PointRemoved(ByVal IndexOfSolid As Long, ByVal IndexOfShape As Long, ByVal IndexOfPoint As Long, ByVal IndexOfTypes As Functions)

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,MouseIcon
Public Property Get MouseIcon() As Picture
    Set MouseIcon = UserControl.MouseIcon
End Property

Public Property Set MouseIcon(ByVal New_MouseIcon As Picture)
    Set UserControl.MouseIcon = New_MouseIcon
    PropertyChanged "MouseIcon"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,50
Public Property Get OBorderLeft() As Double
    OBorderLeft = m_OBorderLeft
End Property

Public Property Let OBorderLeft(ByVal New_OBorderLeft As Double)
    m_OBorderLeft = New_OBorderLeft
    PropertyChanged "OBorderLeft"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,50
Public Property Get OBorderRight() As Double
    OBorderRight = m_OBorderRight
End Property

Public Property Let OBorderRight(ByVal New_OBorderRight As Double)
    m_OBorderRight = New_OBorderRight
    PropertyChanged "OBorderRight"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,50
Public Property Get OBorderTop() As Double
    OBorderTop = m_OBorderTop
End Property

Public Property Let OBorderTop(ByVal New_OBorderTop As Double)
    m_OBorderTop = New_OBorderTop
    PropertyChanged "OBorderTop"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,50
Public Property Get OBorderBottom() As Double
    OBorderBottom = m_OBorderBottom
End Property

Public Property Let OBorderBottom(ByVal New_OBorderBottom As Double)
    m_OBorderBottom = New_OBorderBottom
    PropertyChanged "OBorderBottom"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,30
Public Property Get XStepGrid() As Double
    XStepGrid = m_XStepGrid
End Property

Public Property Let XStepGrid(ByVal New_XStepGrid As Double)
    m_XStepGrid = New_XStepGrid
    PropertyChanged "XStepGrid"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,30
Public Property Get YStepGrid() As Double
    YStepGrid = m_YStepGrid
End Property

Public Property Let YStepGrid(ByVal New_YStepGrid As Double)
    m_YStepGrid = New_YStepGrid
    PropertyChanged "YStepGrid"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,30
Public Property Get ZStepGrid() As Double
    ZStepGrid = m_ZStepGrid
End Property

Public Property Let ZStepGrid(ByVal New_ZStepGrid As Double)
    m_ZStepGrid = New_ZStepGrid
    PropertyChanged "ZStepGrid"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=13,0,0,Asse X
Public Property Get LabelXAxis() As String
    LabelXAxis = m_LabelXAxis
End Property

Public Property Let LabelXAxis(ByVal New_LabelXAxis As String)
    m_LabelXAxis = New_LabelXAxis
    PropertyChanged "LabelXAxis"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=13,0,0,Asse Y
Public Property Get LabelYAxis() As String
    LabelYAxis = m_LabelYAxis
End Property

Public Property Let LabelYAxis(ByVal New_LabelYAxis As String)
    m_LabelYAxis = New_LabelYAxis
    PropertyChanged "LabelYAxis"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=13,0,0,Asse Z
Public Property Get LabelZAxis() As String
    LabelZAxis = m_LabelZAxis
End Property

Public Property Let LabelZAxis(ByVal New_LabelZAxis As String)
    m_LabelZAxis = New_LabelZAxis
    PropertyChanged "LabelZAxis"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=13,0,0,New Figure
Public Property Get FigureTitle() As String
    FigureTitle = m_FigureTitle
End Property

Public Property Let FigureTitle(ByVal New_FigureTitle As String)
    m_FigureTitle = New_FigureTitle
    PropertyChanged "FigureTitle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Picture
Public Property Get Picture() As Picture
    Set Picture = UserControl.Picture
End Property

Public Property Set Picture(ByVal New_Picture As Picture)
    Set UserControl.Picture = New_Picture
    PropertyChanged "Picture"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Image
Public Property Get Image() As Picture
    Set Image = UserControl.Image
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,0,0,0
Public Property Get FixedScale() As Boolean
    FixedScale = m_FixedScale
End Property

Public Property Let FixedScale(ByVal New_FixedScale As Boolean)
    m_FixedScale = New_FixedScale
    PropertyChanged "FixedScale"
End Property

Public Property Get BorderFactor() As Double
    BorderFactor = m_BorderFactor
End Property

Public Property Let BorderFactor(ByVal New_BorderFactor As Double)
    m_BorderFactor = New_BorderFactor
    PropertyChanged "BorderFactor"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,hDC
Public Property Get hdc() As Long
    hdc = UserControl.hdc
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,0,0,0
Public Property Get Saved() As Boolean
    
    'Declarations
    Dim I As Long, SavedAnd As Boolean
    Dim Res As Long
    
    SavedAnd = 1
    'Check if figure is saved
    For I = 1 To SolidNumber
        SavedAnd = SavedAnd And Solid(I).Saved
    Next I
    'Figure is not saved yet
    If SavedAnd = 0 Then
'        Res = MsgBox(LoadResString(418), vbYesNo + vbQuestion, "")
''       Res = MsgBox("La figura visualizzata non  ancora stata salvata. Procedere comunque?", vbYesNo + vbQuestion, "")
'        'User doesn't want save the figure
'        If Res = vbNo Then
            m_Saved = False
'        Else
'            m_Saved = True
'            For I = 1 To SolidNumber
'                mSolids.Remove 1
'            Next I
'        End If
    Else
        m_Saved = True
    End If
    Saved = m_Saved
End Property

Public Property Let Saved(ByVal New_Saved As Boolean)
    m_Saved = New_Saved
    PropertyChanged "Saved"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,0,0,0
Public Property Get Grid() As Boolean
    Grid = m_Grid
End Property

Public Property Let Grid(ByVal New_Grid As Boolean)
    m_Grid = New_Grid
    PropertyChanged "Grid"
End Property


Public Property Get NewEnum() As IUnknown
    'Questa propriet consente di enumerare l'insieme
    'corrente con la sintassi For...Each.
    Set NewEnum = mSolids.[_NewEnum]
End Property

'Return a reference to a shape in the collection
Public Property Get Solid(vntIndexKey As Long) As InBlu_Solid
    Set Solid = mSolids.Item(vntIndexKey)
End Property

'Return number shape in the collection
Public Property Get SolidNumber() As Long
    SolidNumber = mSolids.Count
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=7,0,0,0
Public Property Get SelectEntity() As Functions
    SelectEntity = m_SelectEntity
End Property

Public Property Let SelectEntity(ByVal New_SelectEntity As Functions)
    m_SelectEntity = New_SelectEntity
    PropertyChanged "SelectEntity"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleHeight
Public Property Get ScaleHeight() As Single
    ScaleHeight = UserControl.ScaleHeight
End Property

Public Property Let ScaleHeight(ByVal New_ScaleHeight As Single)
    UserControl.ScaleHeight() = New_ScaleHeight
    PropertyChanged "ScaleHeight"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleLeft
Public Property Get ScaleLeft() As Single
    ScaleLeft = UserControl.ScaleLeft
End Property

Public Property Let ScaleLeft(ByVal New_ScaleLeft As Single)
    UserControl.ScaleLeft() = New_ScaleLeft
    PropertyChanged "ScaleLeft"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleMode
Public Property Get ScaleMode() As Integer
    ScaleMode = UserControl.ScaleMode
End Property

Public Property Let ScaleMode(ByVal New_ScaleMode As Integer)
    UserControl.ScaleMode() = New_ScaleMode
    PropertyChanged "ScaleMode"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,0
Public Property Get Xcenter() As Double
    Xcenter = m_XCenter
End Property

Public Property Let Xcenter(ByVal New_XCenter As Double)
    m_XCenter = New_XCenter
    PropertyChanged "XCenter"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,0
Public Property Get YCenter() As Double
    YCenter = m_YCenter
End Property

Public Property Let YCenter(ByVal New_YCenter As Double)
    m_YCenter = New_YCenter
    PropertyChanged "YCenter"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,0
Public Property Get ZCenter() As Double
    ZCenter = m_ZCenter
End Property

Public Property Let ZCenter(ByVal New_ZCenter As Double)
    m_ZCenter = New_ZCenter
    PropertyChanged "ZCenter"
End Property

Public Property Let Figures(ByVal new_Figures As Collection)

    Set mSolids = Nothing
    Set mSolids = new_Figures
    
End Property

Public Property Get Figures() As Collection

    Set Figures = mSolids
    
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleTop
Public Property Get ScaleTop() As Single
    ScaleTop = UserControl.ScaleTop
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,0
Public Property Get SpinScreenXAngle() As Double
    SpinScreenXAngle = m_SpinScreenXAngle
End Property

Public Property Let SpinScreenXAngle(ByVal New_SpinScreenXAngle As Double)
    m_SpinScreenXAngle = New_SpinScreenXAngle
    PropertyChanged "SpinScreenXAngle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4,0,0,0
Public Property Get SpinScreenYAngle() As Double
    SpinScreenYAngle = m_SpinScreenYAngle
End Property

Public Property Let SpinScreenYAngle(ByVal New_SpinScreenYAngle As Double)
    m_SpinScreenYAngle = New_SpinScreenYAngle
    PropertyChanged "SpinScreenYAngle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=13,0,0,"XY"
Public Property Get Plane() As PlaneType
    Plane = m_Plane
End Property

Public Property Let Plane(ByVal New_Plane As PlaneType)
    m_Plane = New_Plane
    PropertyChanged "Plane"
End Property

Public Property Get Application() As Applications
    Application = m_Applications
End Property

Public Property Let Application(ByVal New_Application As Applications)
    m_Applications = New_Application
    PropertyChanged "Application"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,1,1,0
Public Property Get NumberOfSolid() As Long
    NumberOfSolid = mSolids.Count 'm_NumberOfSolid
End Property

Public Property Let NumberOfSolid(ByVal New_NumberOfSolid As Long)
    If Ambient.UserMode = False Then Err.Raise 387
    If Ambient.UserMode Then Err.Raise 382
    m_NumberOfSolid = New_NumberOfSolid
    PropertyChanged "NumberOfSolid"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,0,0,0
Public Property Get Hold() As Boolean
    Hold = m_Hold
End Property

Public Property Let Hold(ByVal New_Hold As Boolean)
    m_Hold = New_Hold
    PropertyChanged "Hold"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=0,0,0,0
Public Property Get Zoom() As Boolean
    Zoom = m_Zoomed
    If Zoom = False Then
        ZoomProcedure = False
    End If
End Property

Public Property Let Zoom(ByVal New_Zoomed As Boolean)
    m_Zoomed = New_Zoomed
    PropertyChanged "Zoom"
End Property

Public Property Get UnZoom() As Boolean
    UnZoom = m_UnZoomed
End Property

Public Property Let ExternalScale(ByVal New_ExternalScale As Double)
    m_ExternalScale = New_ExternalScale
End Property

Public Property Get ExternalScale() As Double
    ExternalScale = m_ExternalScale
End Property

Public Property Let UnZoom(ByVal New_UnZoomed As Boolean)
    m_UnZoomed = New_UnZoomed
    If UnZoom Then
        ZoomProcedure = False
        tmpZoomExcursionX = 0
        tmpZoomExcursionY = 0
        tmpZoomMinX = 0
        tmpZoomMinY = 0
        m_ManualScale = 0
    End If
    PropertyChanged "UnZoom"
End Property

Public Property Let ScaleTop(ByVal New_ScaleTop As Single)
    UserControl.ScaleTop() = New_ScaleTop
    PropertyChanged "ScaleTop"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleWidth
Public Property Get ScaleWidth() As Single
    ScaleWidth = UserControl.ScaleWidth
End Property

Public Property Let ScaleWidth(ByVal New_ScaleWidth As Single)
    UserControl.ScaleWidth() = New_ScaleWidth
    PropertyChanged "ScaleWidth"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,AutoRedraw
Public Property Get AutoRedraw() As Boolean
    AutoRedraw = UserControl.AutoRedraw
End Property

Public Property Let AutoRedraw(ByVal New_AutoRedraw As Boolean)
    UserControl.AutoRedraw() = New_AutoRedraw
    PropertyChanged "AutoRedraw"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Appearance
Public Property Get Appearance() As Integer
    Appearance = UserControl.Appearance
End Property

Public Property Let Appearance(ByVal New_Appearance As Integer)
    UserControl.Appearance() = New_Appearance
    PropertyChanged "Appearance"
End Property

Public Property Get MoveDeltaSelected() As Boolean
    MoveDeltaSelected = m_MoveDeltaSelected
End Property

Public Property Let MoveDeltaSelected(ByVal New_MoveDeltaSelected As Boolean)
    m_MoveDeltaSelected = New_MoveDeltaSelected
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,CurrentX
Public Property Get CurrentX() As Single
    CurrentX = UserControl.CurrentX
End Property

Public Property Let CurrentX(ByVal New_CurrentX As Single)
    UserControl.CurrentX() = New_CurrentX
    PropertyChanged "CurrentX"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,CurrentY
Public Property Get CurrentY() As Single
    CurrentY = UserControl.CurrentY
End Property

Public Property Let CurrentY(ByVal New_CurrentY As Single)
    UserControl.CurrentY() = New_CurrentY
    PropertyChanged "CurrentY"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,DrawMode
Public Property Get DrawMode() As Integer
    DrawMode = UserControl.DrawMode
End Property

Public Property Let DrawMode(ByVal New_DrawMode As Integer)
    UserControl.DrawMode() = New_DrawMode
    PropertyChanged "DrawMode"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,DrawStyle
Public Property Get DrawStyle() As Integer
    DrawStyle = UserControl.DrawStyle
End Property

Public Property Let DrawStyle(ByVal New_DrawStyle As Integer)
    UserControl.DrawStyle() = New_DrawStyle
    PropertyChanged "DrawStyle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,DrawWidth
Public Property Get DrawWidth() As Integer
    DrawWidth = UserControl.DrawWidth
End Property

Public Property Let DrawWidth(ByVal New_DrawWidth As Integer)
    UserControl.DrawWidth() = New_DrawWidth
    PropertyChanged "DrawWidth"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,FillColor
Public Property Get FillColor() As OLE_COLOR
    FillColor = UserControl.FillColor
End Property

Public Property Let FillColor(ByVal New_FillColor As OLE_COLOR)
    UserControl.FillColor() = New_FillColor
    PropertyChanged "FillColor"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,FillStyle
Public Property Get FillStyle() As Integer
    FillStyle = UserControl.FillStyle
End Property

Public Property Let FillStyle(ByVal New_FillStyle As Integer)
    UserControl.FillStyle() = New_FillStyle
    PropertyChanged "FillStyle"
End Property

''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontBold
'Public Property Get FontBold() As Boolean
'    FontBold = UserControl.FontBold
'End Property
'
'Public Property Let FontBold(ByVal New_FontBold As Boolean)
'    UserControl.FontBold() = New_FontBold
'    PropertyChanged "FontBold"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontItalic
'Public Property Get FontItalic() As Boolean
'    FontItalic = UserControl.FontItalic
'End Property
'
'Public Property Let FontItalic(ByVal New_FontItalic As Boolean)
'    UserControl.FontItalic() = New_FontItalic
'    PropertyChanged "FontItalic"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontName
'Public Property Get FontName() As String
'    FontName = UserControl.FontName
'End Property
'
'Public Property Let FontName(ByVal New_FontName As String)
'    UserControl.FontName() = New_FontName
'    PropertyChanged "FontName"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontSize
'Public Property Get FontSize() As Single
'    FontSize = UserControl.FontSize
'End Property
'
'Public Property Let FontSize(ByVal New_FontSize As Single)
'    UserControl.FontSize() = New_FontSize
'    PropertyChanged "FontSize"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontStrikethru
'Public Property Get FontStrikethru() As Boolean
'    FontStrikethru = UserControl.FontStrikethru
'End Property
'
'Public Property Let FontStrikethru(ByVal New_FontStrikethru As Boolean)
'    UserControl.FontStrikethru() = New_FontStrikethru
'    PropertyChanged "FontStrikethru"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontTransparent
'Public Property Get FontTransparent() As Boolean
'    FontTransparent = UserControl.FontTransparent
'End Property
'
'Public Property Let FontTransparent(ByVal New_FontTransparent As Boolean)
'    UserControl.FontTransparent() = New_FontTransparent
'    PropertyChanged "FontTransparent"
'End Property
'
''AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
''MappingInfo=UserControl,UserControl,-1,FontUnderline
'Public Property Get FontUnderline() As Boolean
'    FontUnderline = UserControl.FontUnderline
'End Property
'
'Public Property Let FontUnderline(ByVal New_FontUnderline As Boolean)
'    UserControl.FontUnderline() = New_FontUnderline
'    PropertyChanged "FontUnderline"
'End Property

Private Sub UserControl_Hide()
    RaiseEvent Hide
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,hWnd
Public Property Get hwnd() As Long
    hwnd = UserControl.hwnd
End Property

Public Property Get AddPointOnEdge() As Boolean
    AddPointOnEdge = m_AddPointOnEdge
End Property

Public Property Let AddPointOnEdge(ByVal New_AddPointOnEdge As Boolean)
    m_AddPointOnEdge = New_AddPointOnEdge
End Property

Public Property Get AddExternalPoint() As Boolean
    AddExternalPoint = m_AddExternalPoint
End Property

Public Property Let AddExternalPoint(ByVal New_AddExternalPoint As Boolean)
    m_AddExternalPoint = New_AddExternalPoint
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,MousePointer
Public Property Get MousePointer() As MousePointerConstants
    MousePointer = UserControl.MousePointer
End Property

Public Property Let MousePointer(ByVal New_MousePointer As MousePointerConstants)
    UserControl.MousePointer() = New_MousePointer
    PropertyChanged "MousePointer"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,BackColor
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Restituisce o imposta il colore di sfondo utilizzato per la visualizzazione di testo e grafica in un oggetto."
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ForeColor
Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Restituisce o imposta il colore di primo piano utilizzato per la visualizzazione di testo e grafica in un oggetto."
    ForeColor = UserControl.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    UserControl.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property


'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Font
Public Property Get Font() As StdFont
   Set Font = mFont
End Property

Public Property Set Font(mnewFont As StdFont)
   With mFont
      .Bold = mnewFont.Bold
      .Italic = mnewFont.Italic
      .Name = mnewFont.Name
      .Size = mnewFont.Size
   End With
   Set UserControl.Font = mFont
   PropertyChanged "Font"
End Property

'Private Sub mFont_FontChanged(ByVal PropertyName As String)
'End Sub


'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,BackStyle
Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indica se il controllo Label o lo sfondo di un controllo Shape  trasparente oppure opaco."
    BackStyle = UserControl.BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    UserControl.BackStyle() = New_BackStyle
    PropertyChanged "BackStyle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,BorderStyle
Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Restituisce o imposta lo stile del bordo di un oggetto."
    BorderStyle = UserControl.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
    UserControl.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Refresh
Public Sub Refresh()
Attribute Refresh.VB_Description = "Ridisegna completamente un oggetto."
    UserControl.Refresh
End Sub

Private Sub Timer1_Timer()
    DoEvents
    If Timer1.Tag = "again" Then
        'User continuos to keep left mouse button pressed
        'and the screen is refreshed
        Timer1.Enabled = False
        Timer1.Tag = "enable"
    ElseIf Timer1.Tag = "start add point" Then
        'This case happens when user
        'keep left mouse button for more then 1 sec.
        Timer1.Enabled = False
        Timer1.Tag = "addpoint"
    ElseIf Timer1.Tag = "addpointagain" Then
        Timer1.Enabled = False
        Timer1.Tag = "addpoint"
    End If
End Sub

Private Sub UserControl_Click()
   RaiseEvent Click
End Sub

Private Sub UserControl_DblClick()
    RaiseEvent DblClick
End Sub

Private Sub UserControl_Initialize()
    Set mFont = New StdFont
    Set UserControl.Font = mFont

    Set mSolids = New Collection
    Set mApplications = New Collection
    ReDim SelectedObject(0)
        
    Timer1.Interval = 350
    Timer1.Enabled = True
    Timer1.Tag = "again"

    'Encoder turned off
    EncSpeedColor = 1
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
    RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    'Declarations
    Dim H As Long
    Dim m_Find As Boolean, tmpX As Single, tmpY As Single
    Dim tmpSelectedConnector As Boolean
    Dim tmpDistOnEdge1 As Double
    Dim tmpPrevDistOnEdge1 As Double
    Dim tmpIndexOnEdge As Long
    Dim tmpPointOnEdge As InBlu_Point_3D
    Dim tmpIndexSplinesOnEdge1 As Long
    Dim ConvX As Double
    Dim ConvY As Double
    
    If Plane <> NoPlane Then
        'Coordinates of mouse converted in the actual scale
        tmpX1 = Format(MinMouseX + ScaleX((X - DrawingArea.Left) / SF, vbPixels, vbMillimeters), "#00.00")
        tmpY1 = Format(MinMouseY + ScaleY((Y - (ScaleTop - (DrawingArea.Top + DrawingArea.Height))) / SF, vbPixels, vbMillimeters), "#00.00")
        tmpX = X
        tmpY = Y
        'Update coordinates
        X = tmpX1
        Y = tmpY1
        RaiseEvent MouseDown(Button, Shift, X, Y)
    End If
    If Plane <> XYZ Then
        If Button = vbLeftButton Then
            'Start Zoom procedure if left mouse button is clicked
            If Zoom Then
                'Check Flag to enabled zoom procedure
                If ZoomProcedure = False Then
                    'Start Zoom procedure and activate
                    'Zoom Drawing
                    Activate_Zoom Val(tmpX), Val(tmpY)
                    shpZoomArea.Visible = True
                End If
            ElseIf m_AddExternalPoint Then
                If InsertPoint = 0 Then
                    With tmpAddExtPntShape
                        .LineColour = vbBlue
                        .LineStyle = vbDot
                        .MarkerColour = vbBlue
                        .RappresentationMode = MarkerAndLines
                    End With
                    tmpAddExtPntSolid.AddShape tmpAddExtPntShape
                    'First Connector point
                    With tmpAddExtPntPoint
                        .MarkerColour = vbBlue
                        .MarkerSize = 6
                        .MarkerStyle = "+"
                        If Plane = xy Then
                            .BaseX = tmpX1 - (10 / SF)
                            .BaseY = tmpY1
                            .BaseZ = 0
                        ElseIf Plane = xz Then
                            .BaseX = tmpX1 - (10 / SF)
                            .BaseY = 0
                            .BaseZ = tmpY1
                        ElseIf Plane = yz Then
                            .BaseX = 0
                            .BaseY = tmpX1 - (10 / SF)
                            .BaseZ = tmpY1
                        End If
                    End With
                    tmpAddExtPntSolid.Shape(1).AddPoint tmpAddExtPntPoint
                    Set tmpAddExtPntPoint = Nothing
                    Set tmpAddExtPntPoint = New InBlu_Point_3D
                    'Point to add
                    With tmpAddExtPntPoint
                        .MarkerColour = vbBlue
                        .MarkerSize = 6
                        .MarkerStyle = "o"
                        .Moveable = False
                        If Plane = xy Then
                            .BaseX = tmpX1
                            .BaseY = tmpY1
                            .BaseZ = 0
                        ElseIf Plane = xz Then
                            .BaseX = tmpX1
                            .BaseY = 0
                            .BaseZ = tmpY1
                        ElseIf Plane = yz Then
                            .BaseX = 0
                            .BaseY = tmpX1
                            .BaseZ = tmpY1
                        End If
                    End With
                    tmpAddExtPntSolid.Shape(1).AddPoint tmpAddExtPntPoint
                    Set tmpAddExtPntPoint = Nothing
                    Set tmpAddExtPntPoint = New InBlu_Point_3D
                    mSolids.Add tmpAddExtPntSolid
                    FixedScale = True
                    Plot
                    InsertPoint = 1
                ElseIf InsertPoint = 1 Then
                    'Find most nearest point of solids collection
                    'respect to the point clicked by the user
                    SelectEntity = PointType
                    tmpSelectedConnector = Find_Selected(tmpX1, tmpY1)
                    If tmpSelectedConnector Then
                        SelectedFirstPoint = SelectedObject(0)
                        m_MoveDeltaSelected = True
                        FixedScale = True
                        InsertPoint = 2
                    End If
                ElseIf InsertPoint = 2 Then
                    'Find most nearest point of solids collection
                    'respect to the point clicked by the user
                    SelectEntity = PointType
                    tmpSelectedConnector = Find_Selected(tmpX1, tmpY1)
                    If tmpSelectedConnector Then
                        SelectedSecondPoint = SelectedObject(0)
                        m_MoveDeltaSelected = True
                        FixedScale = True
                        InsertPoint = 3
                    End If
                End If
            'Insert a new point on edge of figure
            ElseIf m_AddPointOnEdge Then
                'Find the index spline point that match to the mouse coordinates
                For H = 0 To UBound(ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).X())
                    tmpDistOnEdge1 = Sqr((tmpX1 - ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Y(H)) ^ 2 + _
                                    (tmpY1 - ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Z(H)) ^ 2)
                    If H = 0 Then
                        tmpPrevDistOnEdge1 = tmpDistOnEdge1
                        tmpIndexSplinesOnEdge1 = H
                    Else
                        tmpPrevDistOnEdge1 = Quick_Find_Min(tmpDistOnEdge1, tmpPrevDistOnEdge1)
                        If tmpPrevDistOnEdge1 = tmpDistOnEdge1 Then
                            tmpIndexSplinesOnEdge1 = H
                        End If
                    End If
                Next H
                'Find the index of previous original point that can
                'give its properties to the new point
                For H = 0 To UBound(ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).OPtsPointer())
                    If tmpIndexSplinesOnEdge1 > ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).OPtsPointer(H) Then
                        'Here one is added because the array
                        'used to draw start from zero instead
                        'of original point that start from 1
                        tmpIndexOnEdge = H + 1
                    End If
                Next H
                Set tmpPointOnEdge = New InBlu_Point_3D
                'Point setting
                mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).CopyProperties tmpPointOnEdge
                'Discriminate the plane to find
                'the coordinates of new point
                Select Case Plane
                    Case xy
                        tmpPointOnEdge.BaseX = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Y(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseY = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Z(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseZ = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).X(tmpIndexSplinesOnEdge1)
                    Case xz
                        tmpPointOnEdge.BaseX = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Y(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseY = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).X(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseZ = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Z(tmpIndexSplinesOnEdge1)
                    Case yz
                        tmpPointOnEdge.BaseX = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).X(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseY = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Y(tmpIndexSplinesOnEdge1)
                        tmpPointOnEdge.BaseZ = ArraySolids(SelectedObject(0).SolidID - 1).DShapes(SelectedObject(0).ShapeID - 1).Z(tmpIndexSplinesOnEdge1)
                End Select
                
                tmpPointOnEdge.OffsetOrientation.First = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).OffsetOrientation.First
                tmpPointOnEdge.OffsetOrientation.Second = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).OffsetOrientation.Second
                tmpPointOnEdge.OffsetOrientation.Third = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).OffsetOrientation.Third
                
                tmpPointOnEdge.Orientation.First = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).Orientation.First
                tmpPointOnEdge.Orientation.Second = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).Orientation.Second
                tmpPointOnEdge.Orientation.Third = mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Point(tmpIndexOnEdge).Orientation.Third
                
                tmpPointOnEdge.Procedure = 0

'                tmpPointOnEdge.Orientation.First = 0
'                tmpPointOnEdge.Orientation.Second = 180
'                tmpPointOnEdge.Orientation.Third = -90
                If mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).Closed _
                    And tmpIndexOnEdge >= mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).PointsNumber Then
                    mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).AddPoint tmpPointOnEdge
                    RaiseEvent PointAdded(SelectedObject(0).SolidID, SelectedObject(0).ShapeID, mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).PointsNumber + 1)
                Else
                    'To the index is added 1 because it rappresent the previous original point's index respect to where new point has to be put
                    mSolids.Item(SelectedObject(0).SolidID).Shape(SelectedObject(0).ShapeID).AddPoint tmpPointOnEdge, tmpIndexOnEdge + 1
                    RaiseEvent PointAdded(SelectedObject(0).SolidID, SelectedObject(0).ShapeID, tmpIndexOnEdge + 1)
                End If
                Plot
                Set tmpPointOnEdge = Nothing
                MousePointer = 0
                m_AddPointOnEdge = False
            ElseIf mSolids.Count <> 0 Then
                'Find most nearest point of solids collection
                'respect to the point clicked by the user
                m_Find = Find_Selected(tmpX1, tmpY1)
                Plot
            End If
        End If
    End If
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    'Declarations
    Dim I As Long, M As Long, H As Long
    Dim tmpDiffX As Double
    Dim tmpDiffY As Double
    
    If Plane <> NoPlane Then
        'Check if mouse is moving whitin drawing area
        If X <= (DrawingArea.Left + DrawingArea.Width) And X >= DrawingArea.Left _
            And Y >= ScaleTop + ScaleHeight + DrawingArea.Top And Y <= ScaleTop - DrawingArea.Top Then
            'Update the coordinates of mouse based
            'on scale factor and coordinates of figure
            tmpX2 = Format(MinMouseX + ScaleX((X - DrawingArea.Left) / SF, vbPixels, vbMillimeters), "#00.00")
            tmpY2 = Format(MinMouseY + ScaleY((Y - (ScaleTop - (DrawingArea.Top + DrawingArea.Height))) / SF, vbPixels, vbMillimeters), "#00.00")
        End If
    End If
    'Check if Zoom procedure is active
    If ZoomProcedure Then
        'Check if the mouse is moved in right direction
        'or left direction and if is moved toward up or
        'down.This is done cause shape object doesn't accept
        'negative values for its properties
        If X < OX Then
            'Left direction
            shpZoomArea.Left = X
            shpZoomArea.Width = OX - X
            tmpZoomMinX = tmpX2
        Else
            'Right direction
            shpZoomArea.Left = OX
            shpZoomArea.Width = X - OX
            tmpZoomMinX = tmpX1
        End If
        If Y > OY Then
            'Upper direction
            shpZoomArea.Top = Y
            shpZoomArea.Height = Y - OY
            tmpZoomMinY = tmpY1
        Else
            'Lower direction
            shpZoomArea.Top = OY
            shpZoomArea.Height = OY - Y
            tmpZoomMinY = tmpY2
        End If
    End If
    'Check if MoveDelta procedure is active and move
    'the selected point to the new coordinates
    If m_MoveDeltaSelected And Timer1.Tag = "enable" Then
        For M = 0 To UBound(SelectedObject())
            If SelectedObject(M).TypeID = PointType Or SelectedObject(M).TypeID = MultiPointType Then
                    tmpDiffX = (tmpX2 - tmpX1)
                    tmpDiffY = (tmpY2 - tmpY1)
                    'Check which is the plane
                    'of rappresentation
                    Select Case Plane
                        Case xy
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                        tmpDiffX, tmpDiffY, 0
                        Case xz
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                        tmpDiffX, 0, tmpDiffY
                        Case yz
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                        0, tmpDiffX, tmpDiffY
                    End Select
            ElseIf SelectedObject(M).TypeID = ShapesType Or SelectedObject(M).TypeID = MultiShapeType Then
                tmpDiffX = (tmpX2 - tmpX1)
                tmpDiffY = (tmpY2 - tmpY1)
                'Check which is the plane
                'of rappresentation
                Select Case Plane
                    Case xy
                        For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                    tmpDiffX, tmpDiffY, 0
                        Next I
                    Case xz
                        For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                    tmpDiffX, 0, tmpDiffY
                        Next I
                    Case yz
                        For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                            mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                    0, tmpDiffX, tmpDiffY
                        Next I
                End Select
            ElseIf SelectedObject(M).TypeID = SolidType Or SelectedObject(M).TypeID = MultiSolidType Then
                tmpDiffX = (tmpX2 - tmpX1)
                tmpDiffY = (tmpY2 - tmpY1)
                'Check which is the plane
                'of rappresentation
                Select Case Plane
                    Case xy
                        For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                        tmpDiffX, tmpDiffY, 0
                            Next I
                        Next H
                    Case xz
                        For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                        tmpDiffX, 0, tmpDiffY
                            Next I
                        Next H
                    Case yz
                        For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                         0, tmpDiffX, tmpDiffY
                            Next I
                        Next H
                End Select
            End If
        Next M
        tmpX1 = tmpX2
        tmpY1 = tmpY2
        'Redraw the figure
        Plot
        'Start timer to count 1 millisecond of
        'delay before refresh the screen.
        'Timer is used to give the CPU the time
        'to redraw the figure,because the mouse's
        'frequency is too high
        Timer1.Interval = 1
        Timer1.Enabled = True
        Timer1.Tag = "again"
    End If
    If Plane <> NoPlane Then
        'Updates coordinates for user
        X = tmpX2
        Y = tmpY2
    End If

    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    'Declarations
    Dim I As Long, H As Long, M As Long, r As Long
    Dim tmpSelectedPoint As FindOnScreen
    Dim tmpIndex As Long, tmpDist As Double
    Dim tmpdist1 As Double, tmpdist2 As Double
    Dim tmpDiffX As Double
    Dim tmpDiffY As Double
    Dim tmpSelectedObject1 As FindOnScreen
    Dim tmpSelectedObject2 As FindOnScreen
    Static tmpFirstObject As FindOnScreen

    If Plane <> NoPlane And m_MoveDeltaSelected = False Then
        'Update coordinates
        X = Format(MinMouseX + ScaleX((X - DrawingArea.Left) / SF, vbPixels, vbMillimeters), "#00.00")
        Y = Format(MinMouseY + ScaleY((Y - (ScaleTop - (DrawingArea.Top + DrawingArea.Height))) / SF, vbPixels, vbMillimeters), "#00.00")
    End If
    'Close Zoom procedure and redraw
    If ZoomProcedure Then
        'Reset some flags and set new
        'values of excursion
        ZoomProcedure = False
        shpZoomArea.Visible = False
        tmpZoomExcursionX = shpZoomArea.Width
        tmpZoomExcursionY = shpZoomArea.Height
        'Redraw the figure
        Plot
    End If
    'Close MoveDelta procedure and move point selected
    'in the last coordinates of mouse
    If m_MoveDeltaSelected Then
        If Timer1.Tag <> "MoveDelta" Then
            'Updates coordinates
            tmpX2 = Format(MinMouseX + ScaleX((X - DrawingArea.Left) / SF, vbPixels, vbMillimeters), "#00.00")
            tmpY2 = Format(MinMouseY + ScaleY((Y - (ScaleTop - (DrawingArea.Top + DrawingArea.Height))) / SF, vbPixels, vbMillimeters), "#00.00")
            For M = 0 To UBound(SelectedObject())
                If SelectedObject(M).TypeID = PointType Or SelectedObject(M).TypeID = MultiPointType Then
                        tmpDiffX = (tmpX2 - tmpX1)
                        tmpDiffY = (tmpY2 - tmpY1)
                        'Check which is the plane
                        'of rappresentation
                        Select Case Plane
                            Case xy
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                            tmpDiffX, tmpDiffY, 0
                            Case xz
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                            tmpDiffX, 0, tmpDiffY
                            Case yz
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(SelectedObject(M).PointID).MoveDelta _
                                            0, tmpDiffX, tmpDiffY
                        End Select
                ElseIf SelectedObject(M).TypeID = ShapesType Or SelectedObject(M).TypeID = MultiShapeType Then
                    tmpDiffX = (tmpX2 - tmpX1)
                    tmpDiffY = (tmpY2 - tmpY1)
                    'Check which is the plane
                    'of rappresentation
                    Select Case Plane
                        Case xy
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                        tmpDiffX, tmpDiffY, 0
                            Next I
                        Case xz
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                        tmpDiffX, 0, tmpDiffY
                            Next I
                        Case yz
                            For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).PointsNumber
                                mSolids.Item(SelectedObject(M).SolidID).Shape(SelectedObject(M).ShapeID).Point(I).MoveDelta _
                                        0, tmpDiffX, tmpDiffY
                            Next I
                    End Select
                ElseIf SelectedObject(M).TypeID = SolidType Or SelectedObject(M).TypeID = MultiSolidType Then
                    tmpDiffX = (tmpX2 - tmpX1)
                    tmpDiffY = (tmpY2 - tmpY1)
                    'Check which is the plane
                    'of rappresentation
                    Select Case Plane
                        Case xy
                            For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                                For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                    mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                            tmpDiffX, tmpDiffY, 0
                                Next I
                            Next H
                        Case xz
                            For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                                For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                    mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                            tmpDiffX, 0, tmpDiffY
                                Next I
                            Next H
                        Case yz
                            For H = 1 To mSolids.Item(SelectedObject(M).SolidID).ShapesNumber
                                For I = 1 To mSolids.Item(SelectedObject(M).SolidID).Shape(H).PointsNumber
                                    mSolids.Item(SelectedObject(M).SolidID).Shape(H).Point(I).MoveDelta _
                                             0, tmpDiffX, tmpDiffY
                                Next I
                            Next H
                    End Select
                End If
            Next M
        End If
        'Reset some flags and return
        'to the original icon of pointer
        Timer1.Tag = "again"
        Timer1.Enabled = True
    End If
    If m_AddExternalPoint And InsertPoint = 2 Then
        'Find most nearest point of selected shape
        'respect to the point where mouse is released by the use
        For I = 1 To mSolids.Count - 1
            tmpSelectedObject1.SolidID = I
            For r = 1 To mSolids.Item(I).ShapesNumber
                tmpSelectedObject1.ShapeID = r
                'Find the point most near to mouse click point
                mSolids.Item(I).Shape(r).GetNearestPoint tmpX2, tmpY2, Plane, tmpSelectedObject1.PointID, tmpSelectedObject1.Dist
                If r = 1 And I = 1 Then
                    tmpSelectedObject2 = tmpSelectedObject1
                Else
                    tmpDist = Quick_Find_Min(tmpSelectedObject2.Dist, tmpSelectedObject1.Dist)
                    If tmpDist <> tmpSelectedObject2.Dist Then
                        tmpSelectedObject2 = tmpSelectedObject1
                    End If
                End If
            Next r
        Next I
        
        mSolids.Item(mSolids.Count).Shape(1).Point(1).MoveTo _
        mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).X, _
        mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Y, _
        mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Z
        
        mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification = tmpSelectedObject2.PointID
        
        'Second Connector point
        With tmpAddExtPntPoint
            .MarkerColour = vbBlue
            .MarkerSize = 6
            .MarkerStyle = "+"
            If Plane = xy Then
                .BaseX = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseX + (10 / SF)
                .BaseY = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseY
                .BaseZ = 0
            ElseIf Plane = xz Then
                .BaseX = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseX + (10 / SF)
                .BaseY = 0
                .BaseZ = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseZ
            ElseIf Plane = yz Then
                .BaseX = 0
                .BaseY = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseY + (10 / SF)
                .BaseZ = mSolids.Item(NumberOfSolid).Shape(1).Point(2).BaseZ
            End If
        End With
        mSolids.Item(NumberOfSolid).Shape(1).AddPoint tmpAddExtPntPoint
        Set tmpAddExtPntPoint = Nothing
        tmpFirstObject = tmpSelectedObject2
        Plot
    ElseIf m_AddExternalPoint And InsertPoint = 3 Then
        'Find most nearest point of selected shape
        'respect to the point where mouse is released by the use
        For I = 1 To mSolids.Count - 1
            tmpSelectedObject1.SolidID = I
            For r = 1 To mSolids.Item(I).ShapesNumber
                tmpSelectedObject1.ShapeID = r
                'Find the point most near to mouse click point
                mSolids.Item(I).Shape(r).GetNearestPoint tmpX2, tmpY2, Plane, tmpSelectedObject1.PointID, tmpSelectedObject1.Dist
                If r = 1 And I = 1 Then
                    tmpSelectedObject2 = tmpSelectedObject1
                Else
                    tmpDist = Quick_Find_Min(tmpSelectedObject2.Dist, tmpSelectedObject1.Dist)
                    If tmpDist <> tmpSelectedObject2.Dist Then
                        tmpSelectedObject2 = tmpSelectedObject1
                    End If
                End If
            Next r
        Next I
        'Check if second connector is linked with a valide point
        If tmpFirstObject.SolidID = tmpSelectedObject2.SolidID And tmpFirstObject.ShapeID = tmpSelectedObject2.ShapeID And _
                (Abs(tmpSelectedObject2.PointID - mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification) = 1 Or _
                (tmpSelectedObject2.PointID - mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification) = 0) Then
            
            mSolids.Item(mSolids.Count).Shape(1).Point(3).MoveTo _
            mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).X, _
            mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Y, _
            mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Z
            
            mSolids.Item(mSolids.Count).Shape(1).Point(3).Identification = tmpSelectedObject2.PointID
            'Update the properties of new point
            'It takes the properties of points on the edge

            mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).CopyProperties tmpAddExtPntSolid.Shape(1).Point(2)
            If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Identification = Sprayer Then
                mSolids.Item(mSolids.Count).Shape(1).Point(2).Orientation.First = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Orientation.First
                mSolids.Item(mSolids.Count).Shape(1).Point(2).Orientation.Second = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Orientation.Second
                mSolids.Item(mSolids.Count).Shape(1).Point(2).Orientation.Third = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Orientation.Third
            
                mSolids.Item(mSolids.Count).Shape(1).Point(2).OffsetOrientation.First = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).OffsetOrientation.First
                mSolids.Item(mSolids.Count).Shape(1).Point(2).OffsetOrientation.Second = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).OffsetOrientation.Second
                mSolids.Item(mSolids.Count).Shape(1).Point(2).OffsetOrientation.Third = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).OffsetOrientation.Third
            End If
            With mSolids.Item(mSolids.Count).Shape(1).Point(2)
                'For the coordinate not visible on the screen
                'is calculated a balanced average
                Select Case Plane
                    Case xy
                        tmpdist1 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).X - mSolids.Item(mSolids.Count).Shape(1).Point(1).X) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Y - mSolids.Item(mSolids.Count).Shape(1).Point(1).Y) ^ 2)
                        tmpdist2 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).X - mSolids.Item(mSolids.Count).Shape(1).Point(3).X) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Y - mSolids.Item(mSolids.Count).Shape(1).Point(3).Y) ^ 2)
                        .BaseZ = mSolids.Item(mSolids.Count).Shape(1).Point(1).Z + (mSolids.Item(mSolids.Count).Shape(1).Point(3).Z - mSolids.Item(mSolids.Count).Shape(1).Point(1).Z) * (tmpdist1 / (tmpdist1 + tmpdist2))
                    Case xz
                        tmpdist1 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).X - mSolids.Item(mSolids.Count).Shape(1).Point(1).X) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Z - mSolids.Item(mSolids.Count).Shape(1).Point(1).Z) ^ 2)
                        tmpdist2 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).X - mSolids.Item(mSolids.Count).Shape(1).Point(3).X) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Z - mSolids.Item(mSolids.Count).Shape(1).Point(3).Z) ^ 2)
                        .BaseY = mSolids.Item(mSolids.Count).Shape(1).Point(1).Y + (mSolids.Item(mSolids.Count).Shape(1).Point(3).Y - mSolids.Item(mSolids.Count).Shape(1).Point(1).Y) * (tmpdist1 / (tmpdist1 + tmpdist2))
                    Case yz
                        tmpdist1 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).Y - mSolids.Item(mSolids.Count).Shape(1).Point(1).Y) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Z - mSolids.Item(mSolids.Count).Shape(1).Point(1).Z) ^ 2)
                        tmpdist2 = Sqr((mSolids.Item(mSolids.Count).Shape(1).Point(2).Y - mSolids.Item(mSolids.Count).Shape(1).Point(3).Y) ^ 2 + (mSolids.Item(mSolids.Count).Shape(1).Point(2).Z - mSolids.Item(mSolids.Count).Shape(1).Point(3).Z) ^ 2)
                        .BaseX = mSolids.Item(mSolids.Count).Shape(1).Point(1).X + (mSolids.Item(mSolids.Count).Shape(1).Point(3).X - mSolids.Item(mSolids.Count).Shape(1).Point(1).X) * (tmpdist1 / (tmpdist1 + tmpdist2))
                End Select
            End With

            mSolids.Item(mSolids.Count).Shape(1).Point(2).Procedure = 0

            If mSolids.Item(mSolids.Count).Shape(1).Point(3).Identification > mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification Then
                'Add the point to the edge of figure
                'in the indicate position
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).AddPoint _
                    mSolids.Item(mSolids.Count).Shape(1).Point(2), tmpSelectedObject2.PointID
                    RaiseEvent PointAdded(tmpSelectedObject2.SolidID, tmpSelectedObject2.ShapeID, mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).PointsNumber)
            ElseIf mSolids.Item(mSolids.Count).Shape(1).Point(3).Identification < mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification Then
                'Add the point to the edge of figure
                'in the indicate position
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).AddPoint _
                    mSolids.Item(mSolids.Count).Shape(1).Point(2), mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification
                    RaiseEvent PointAdded(tmpSelectedObject2.SolidID, tmpSelectedObject2.ShapeID, mSolids.Item(mSolids.Count).Shape(1).Point(1).Identification)
            ElseIf tmpSelectedObject2.PointID = mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).PointsNumber Then
                'Add the point to the edge of figure
                'in the indicate position
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).AddPoint _
                    mSolids.Item(mSolids.Count).Shape(1).Point(2)
                    RaiseEvent PointAdded(tmpSelectedObject2.SolidID, tmpSelectedObject2.ShapeID, mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).PointsNumber)
            ElseIf tmpSelectedObject2.PointID = 1 Then _
                'Add the point to the edge of figure
                'in the indicate position
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).AddPoint _
                    mSolids.Item(mSolids.Count).Shape(1).Point(2), 1
                    RaiseEvent PointAdded(tmpSelectedObject2.SolidID, tmpSelectedObject2.ShapeID, 1)
            End If
            'Remove solid for external point from selection's array
            ReDim SelectedObject(0)
            'Remove solid for external point from solids collection
            mSolids.Remove NumberOfSolid
            Plot
            'Reset all temporay variables
            InsertPoint = 0
            m_AddExternalPoint = False
            Set tmpAddExtPntPoint = Nothing
            Set tmpAddExtPntShape = Nothing
            Set tmpAddExtPntSolid = Nothing
        Else
            With mSolids.Item(mSolids.Count).Shape(1).Point(3)
                Select Case Plane
                    Case xy
                        .MoveTo mSolids.Item(mSolids.Count).Shape(1).Point(2).X + (10 / SF), _
                                mSolids.Item(mSolids.Count).Shape(1).Point(2).Y, _
                                0
                    Case xz
                        .MoveTo mSolids.Item(mSolids.Count).Shape(1).Point(2).X + (10 / SF), _
                                0, _
                                mSolids.Item(mSolids.Count).Shape(1).Point(2).Z
                    Case yz
                        .MoveTo 0, _
                                mSolids.Item(mSolids.Count).Shape(1).Point(2).Y + (10 / SF), _
                                mSolids.Item(mSolids.Count).Shape(1).Point(2).Z
                End Select
            End With
            InsertPoint = 2
            mSolids.Item(mSolids.Count).Shape(1).Point(3).Selected = False
            ReDim SelectedObject(0)
            Plot
            MsgBox LoadResString(406) _
                    & LoadResString(407), vbInformation, LoadResString(408) _
                    & LoadResString(409)
'                   MsgBox "Per aggiungere un punto selezionare due " _
                    & "punti consecutivi o un estremo", vbInformation, "Messaggio " _
                    & "di Sistema"
        End If
    End If
    RaiseEvent MouseUp(Button, Shift, X, Y)
End Sub

'Il carattere di sottolineatura che segue "Circle"  necessario in quanto
'si tratta di una parola riservata di VBA.
'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Circle
Public Sub Circle_(X As Single, Y As Single, Radius As Single, Optional Color As Long, Optional StartPos As Single, Optional EndPos As Single, Optional Aspect As Single = 1)
    If Color = 0 Then
        Color = ForeColor
    End If
    UserControl.Circle (X, Y), Radius, Color, StartPos, EndPos, Aspect
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Cls
Public Sub Cls()
Attribute Cls.VB_Description = "Cancella le immagini e il testo generati in fase di esecuzione da un form o da un controllo Image o PictureBox."
    UserControl.Cls
End Sub

Private Sub UserControl_Paint()
    RaiseEvent Paint
End Sub

'Il carattere di sottolineatura che segue "Point"  necessario in quanto
'si tratta di una parola riservata di VBA.
'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Point
Public Function Point(X As Single, Y As Single) As Long
Attribute Point.VB_Description = "Restituisce come intero di tipo Long il colore RGB del punto specificato in un oggetto Form o PictureBox."
    Point = UserControl.Point(X, Y)
End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,PopupMenu
Public Sub PopupMenu(ByVal Menu As Object, Optional ByVal flags As Variant, Optional ByVal X As Variant, Optional ByVal Y As Variant, Optional ByVal DefaultMenu As Variant)
Attribute PopupMenu.VB_Description = "Visualizza un menu di scelta rapida in un oggetto MDIForm o Form."
    UserControl.PopupMenu Menu, flags, X, Y, DefaultMenu
End Sub

Public Sub Open_Selected(MsgError As String, ByVal EnableErrorMsg As Boolean)

    'Declarations
    Dim I As Long

    If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID > 0 Then
        For I = 0 To UBound(SelectedObject())
            Select Case SelectedObject(I).TypeID
                Case ShapesType, MultiShapeType
                    mSolids.Item(SelectedObject(I).SolidID).Shape(SelectedObject(I).ShapeID).Closed = False
                Case SolidType, MultiSolidType
                    mSolids.Item(SelectedObject(I).SolidID).Closed = False
                Case Else
                    'User tried to close a not valide object
                    If EnableErrorMsg Then
                        MsgBox LoadResString(410), vbInformation, LoadResString(368)
'                        MsgBox "Selezione errata , selezionare una figura", vbInformation, "Comunicazione di sistema"
                    Else
                        MsgError = LoadResString(410)
                    End If
            End Select
        Next I
    Else
        'User tried to close a not valide object
        If EnableErrorMsg Then
            MsgBox LoadResString(411), vbInformation, LoadResString(368)
'           MsgBox "Selezionare qualcosa per aprirlo", vbInformation, "Comunicazione di sistema"
        Else
            MsgError = LoadResString(411)
        End If
    End If
    Plot
End Sub

Public Sub Aggregate(MsgError As String, ByVal EnableErrorMsg As Boolean)

    'Declarations
    Dim M As Long
    
    If UBound(SelectedObject()) > 0 Then
        If (SelectedObject(0).TypeID = MultiSolidType Or SelectedObject(0).TypeID = SolidType) _
            And (SelectedObject(1).TypeID = MultiSolidType Or SelectedObject(1).TypeID = SolidType) Then
            'Assign all shapes of selected solid to
            'the container solid
            For M = 1 To mSolids.Item(SelectedObject(1).SolidID).ShapesNumber
                mSolids.Item(SelectedObject(0).SolidID).AddShape mSolids.Item(SelectedObject(1).SolidID).Shape(M)
            Next M
            'Remove old solid
            mSolids.Remove SelectedObject(1).SolidID
        Else
            If EnableErrorMsg Then
                MsgBox LoadResString(412), vbInformation, LoadResString(368)
'               MsgBox "Selezionare due figure per unirle", vbInformation, "Comunicazione di sistema"
            Else
                MsgError = LoadResString(412)
            End If
        End If
    Else
        If EnableErrorMsg Then
            MsgBox LoadResString(412), vbInformation, LoadResString(368)
        Else
            MsgError = LoadResString(412)
        End If
    End If
End Sub

Public Sub AddFigure()

    'Declarations
    Dim tmpSolid As New InBlu_Solid
    Dim tmpShape As New InBlu_Shape_3D
    Dim tmpPoint As New InBlu_Point_3D
    Dim I As Long
    
    'Set the coordinates of point
    tmpPoint.BaseX = 0
    tmpPoint.BaseY = 0
    tmpPoint.BaseZ = 0
    tmpPoint.Orientation.First = 0
    tmpPoint.Orientation.Second = 180
    tmpPoint.Orientation.Third = -90
    'Assign new point to the shape
    'And the shape to the solid
    tmpSolid.AddShape tmpShape
    tmpSolid.Shape(1).AddPoint tmpPoint
    'Remove all figure if hold property is not setted
    'and if axis is on a valide plane
    If Hold = False And Plane <> NoPlane Then
        For I = NumberOfSolid To 1 Step -1
            mSolids.Remove I
        Next I
    End If
    mSolids.Add tmpSolid
    'Remove all temporary variables
    Set tmpPoint = Nothing
    Set tmpShape = Nothing
    Set tmpSolid = Nothing
End Sub

Public Sub LetSelectedForAxis(SelSolids() As Long, SelShapes() As Long, SelPoints() As Long, SelTypes() As Functions)

    'Declarations
    Dim I As Long
    
    ReDim SelectedObject(UBound(SelSolids()))
    'Conversion of format of selected object
    For I = 0 To UBound(SelectedObject())
        SelectedObject(I).SolidID = SelSolids(I)
        SelectedObject(I).ShapeID = SelShapes(I)
        SelectedObject(I).PointID = SelPoints(I)
        SelectedObject(I).TypeID = SelTypes(I)
    Next I
End Sub

Public Sub GetSelectedForAxis(SelSolids() As Long, SelShapes() As Long, SelPoints() As Long, SelTypes() As Functions)

    'Declarations
    Dim I As Long
    
    ReDim SelSolids(UBound(SelectedObject()))
    ReDim SelShapes(UBound(SelectedObject()))
    ReDim SelPoints(UBound(SelectedObject()))
    ReDim SelTypes(UBound(SelectedObject()))
        
    'Conversion of format of selected object
    For I = 0 To UBound(SelectedObject())
        SelSolids(I) = SelectedObject(I).SolidID
        SelShapes(I) = SelectedObject(I).ShapeID
        SelPoints(I) = SelectedObject(I).PointID
        SelTypes(I) = SelectedObject(I).TypeID
    Next I
End Sub

Public Sub Remove_Selected(MsgError As String, ByVal EnableErrorMsg As Boolean)

    'Declarations
    Dim Answer As Long
    Dim I As Long
    Dim RemSolidsIndex() As Long, RemShapesIndex() As Long, RemPointsIndex() As Long
    
    If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID > 0 Then
        Answer = MsgBox(LoadResString(413), vbOKCancel, LoadResString(414))
'       Answer = MsgBox("Sei sicuro di voler cancellare ? ", vbOKCancel, "Richiesta di sistema ")
        If Answer = vbOK Then
            For I = 0 To UBound(SelectedObject())
                If SelectedObject(I).TypeID = SolidType Or SelectedObject(I).TypeID = MultiSolidType Then
                    mSolids.Remove SelectedObject(I).SolidID
                    RaiseEvent PointRemoved(SelectedObject(I).SolidID, 0, 0, SelectedObject(I).TypeID)
                ElseIf SelectedObject(I).TypeID = ShapesType Or SelectedObject(I).TypeID = MultiShapeType Then
                    'Check if removed shape is the last shape
                    If mSolids.Item(SelectedObject(I).SolidID).ShapesNumber = 1 Then
                        mSolids.Remove SelectedObject(I).SolidID
                        RaiseEvent PointRemoved(SelectedObject(I).SolidID, 0, 0, SelectedObject(I).TypeID)
                    Else
                        mSolids.Item(SelectedObject(I).SolidID).RemoveShape SelectedObject(0).ShapeID
                        RaiseEvent PointRemoved(SelectedObject(I).SolidID, SelectedObject(0).ShapeID, 0, SelectedObject(I).TypeID)
                    End If
                ElseIf SelectedObject(I).TypeID = PointType Or SelectedObject(I).TypeID = MultiPointType Then
                    If mSolids.Item(SelectedObject(I).SolidID).Shape(SelectedObject(I).ShapeID).PointsNumber = 1 Then
                        mSolids.Remove SelectedObject(I).SolidID
                        RaiseEvent PointRemoved(SelectedObject(I).SolidID, 0, 0, SelectedObject(I).TypeID)
                    Else
                        mSolids.Item(SelectedObject(I).SolidID).Shape(SelectedObject(I).ShapeID).RemovePoint SelectedObject(I).PointID
                        RaiseEvent PointRemoved(SelectedObject(I).SolidID, SelectedObject(I).ShapeID, SelectedObject(I).PointID, SelectedObject(I).TypeID)
                    End If
                End If
            Next I
            If mSolids.Count = 0 Then Plane = NoPlane
            Reset_Selection
            Plot
            'Raise Selected event
            Find_Selected 25000, 25000
        End If
    Else
        'User tried to remove something without selection
        If EnableErrorMsg Then
            MsgBox LoadResString(415), vbInformation, LoadResString(368)
'           MsgBox "Selezionare qualcosa per rimuoverlo", vbInformation, "Comunicazione di sistema"
        Else
            MsgError = LoadResString(415)
        End If
    End If
End Sub


Public Sub Closed_Selected(MsgError As String, ByVal EnableErrorMsg As Boolean)

    'Declarations
    Dim I As Long

    If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID > 0 Then
        For I = 0 To UBound(SelectedObject())
            Select Case SelectedObject(I).TypeID
                Case ShapesType, MultiShapeType
                    mSolids.Item(SelectedObject(I).SolidID).Shape(SelectedObject(I).ShapeID).Closed = True
                Case SolidType, MultiSolidType
                    mSolids.Item(SelectedObject(I).SolidID).Closed = True
                Case Else
                    'User tried to close a not valide object
                    If EnableErrorMsg Then
                        MsgBox LoadResString(416), vbInformation, LoadResString(368)
'                       MsgBox "Selezione errata , selezionare una figura", vbInformation, "Comunicazione di sistema"
                    Else
                        MsgError = LoadResString(416)
                    End If
            End Select
        Next I
    Else
        'User tried to close a not valide object
        If EnableErrorMsg Then
            MsgBox LoadResString(417), vbInformation, LoadResString(368)
'           MsgBox "Selezionare qualcosa per chiuderlo", vbInformation, "Comunicazione di sistema"
        Else
            MsgError = LoadResString(417)
        End If
    End If
    Plot
End Sub

Private Sub UserControl_Resize()
    FixedScale = False
    RaiseEvent Resize
End Sub

'Il carattere di sottolineatura che segue "PSet"  necessario in quanto
'si tratta di una parola riservata di VBA.
'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,PSet
Public Sub PSet_(X As Single, Y As Single, Color As Long)
    UserControl.PSet Step(X, Y), Color
End Sub

'Il carattere di sottolineatura che segue "Scale"  necessario in quanto
'si tratta di una parola riservata di VBA.
'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Scale
Public Sub Scale_(Optional X1 As Variant, Optional Y1 As Variant, Optional X2 As Variant, Optional Y2 As Variant)
    UserControl.Scale (X1, Y1)-(X2, Y2)
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleX
Public Function ScaleX(ByVal Width As Single, Optional ByVal FromScale As Variant, Optional ByVal ToScale As Variant) As Single
Attribute ScaleX.VB_Description = "Converte il valore della larghezza di un oggetto Form o Printer o di un controllo PictureBox da un'unit di misura a un'altra."
    ScaleX = UserControl.ScaleX(Width, FromScale, ToScale)
End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,ScaleY
Public Function ScaleY(ByVal Height As Single, Optional ByVal FromScale As Variant, Optional ByVal ToScale As Variant) As Single
Attribute ScaleY.VB_Description = "Converte il valore dell'altezza di un oggetto Form o Printer o di un controllo PictureBox da un'unit di misura a un'altra."
    ScaleY = UserControl.ScaleY(Height, FromScale, ToScale)
End Function

Private Sub UserControl_Show()
    RaiseEvent Show
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,TextHeight
Public Function TextHeight(ByVal Str As String) As Single
Attribute TextHeight.VB_Description = "Restituisce l'altezza di una stringa di testo cos come verrebbe stampata con il tipo di carattere corrente."
    TextHeight = UserControl.TextHeight(Str)
End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,TextWidth
Public Function TextWidth(ByVal Str As String) As Single
Attribute TextWidth.VB_Description = "Restituisce la larghezza di una stringa di testo cos come verrebbe stampata con il tipo di carattere corrente."
    TextWidth = UserControl.TextWidth(Str)
End Function

Private Function Scale_Factor(ByVal ExcursionX2d As Double, ByVal ExcursionY2d As Double, _
                            ByVal DAreaWidth As Double, ByVal DareaHeight As Double) As Single
    'Funzione che calcola la scala per la rappresentazione di un grafico
    'PARAMETRI D'INGRESSO:
    ' AsseX                 :Rappresenta l'escursione dal min al
    ' max delle coordinate che vanno in ascissa
    ' AsseY                 :Rappresenta l'escursione dal min al
    ' max delle coordinate che vanno in ordinata
    ' Larghezza_Area_Disegno:Rappresenta l'ascissa dell'area di disegno
    ' Altezza_Area_Disegno  :Rappresenta l'ordinata dell'area di disegno
    'PARAMETRI D'USCITA:
    ' Calcolo_FattoreScala  :Rappresenta la scala
      
    'Declarations
    Dim Ratio As Single, Ratio2 As Single
  
    'Find the ratio
    Ratio = DAreaWidth / ExcursionX2d
    Ratio2 = DareaHeight / ExcursionY2d
    'Find the scale factor
    If Ratio < Ratio2 Then
        Scale_Factor = Ratio / BorderFactor
    ElseIf Ratio2 < Ratio Then
        Scale_Factor = Ratio2 / BorderFactor
    End If
    ExternalScale = Scale_Factor
End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=14
Public Sub Plot()

    'Declarations
    Dim I As Long, K As Long, M As Long, s As Long
    Dim ArrPts() As POINTAPI
    Dim Lim As Long, Prev As Long, Po As Long
    Dim Firsttime As Boolean, Colour As Long
    Dim OForeColor As Long, ODrawStyle As Long, ODrawWidth As Long
    Dim EndPattern As Long
    Dim tmpYCoordinates() As Double, tmpZCoordinates() As Double
    '***********************************************
    
    Dim tmpExcursionX As Double, tmpExcursionY As Double
    Dim tmpMaxz1 As Double, tmpMaxy1 As Double
    Dim tmpMinz1 As Double, tmpMiny1 As Double
    Dim tmpMaxz2 As Double, tmpMaxy2 As Double
    Dim tmpMinz2 As Double, tmpMiny2 As Double
    Static tmpPrevMaxy As Double
    Static tmpPrevMaxz As Double
    Static tmpPrevMiny As Double
    Static tmpPrevMinz As Double
    Dim tmpCenterX As Double, tmpCenterY As Double
    Dim ScaleWidthTar As Long
    Dim tmpMinGridX As Double, tmpMinGridY As Double
    Static XScreenLabel As String
    Static YScreenLabel As String
    Static XStep As Double
    Static YStep As Double

    Dim LineStartX As Single
    Dim LineStartY As Single
    Dim LineEndX As Single
    Dim LineEndY As Single
    Dim LineStartXTool As Single
    Dim LineStartYTool As Single
    Dim LineEndXTool As Single
    Dim LineEndYTool As Single

    Dim GeomCalc As Inblu_Geom_Calculator
    Set GeomCalc = New Inblu_Geom_Calculator
    Dim NewZYXAngles As Inblu_Angles
    Set NewZYXAngles = New Inblu_Angles

    Dim Origin As InBlu_Point_3D
    Set Origin = New InBlu_Point_3D
    
    Dim RotX(1 To 4, 1 To 4) As Double
    Dim RotY(1 To 4, 1 To 4) As Double
    Dim RotZ(1 To 4, 1 To 4) As Double
    Dim RotO(1 To 4, 1 To 4) As Double
    Dim RotA(1 To 4, 1 To 4) As Double
    Dim RotT(1 To 4, 1 To 4) As Double
    Dim ROA() As Double
    Dim ROAT() As Double
    Dim RZY() As Double
    Dim RZYX() As Double
    Dim RTot() As Double
    Dim NewXAngle As Double
    Dim NewYAngle As Double
    Dim NewZAngle As Double
    Dim RFA(1 To 4, 1 To 4) As Double
    Dim RFT(1 To 4, 1 To 4) As Double
    Dim RFAT() As Double
    Dim RFOAT() As Double

    
    
    Dim CoordPointTemp(1 To 4, 1) As Double
    Dim CoordPointTempTool(1 To 4, 1) As Double
    Dim RotatePointTemp() As Double
    Dim RotatePointTempTool() As Double
    Dim CenterMatrix(1 To 4, 1) As Double
    Dim Difference() As Double
    Dim DifferenceTool() As Double
    Dim Add() As Double
    Dim AddTool() As Double
    
    

    '***********************************************
    
    'This case happens when last solid in the
    'collection is removed
    If NumberOfSolid > 0 Or Plane <> NoPlane Then
        'Save original settings of axis
        OForeColor = ForeColor
        ODrawStyle = DrawStyle
        ODrawWidth = DrawWidth
        Select Case Plane
            Case PlaneType.xy
                'XY Rappresentation
                SpinScreenXAngle = 0
                SpinScreenYAngle = 90
                SpinScreenXSAngle = 90
                XScreenLabel = LabelXAxis
                YScreenLabel = LabelYAxis
                XStep = XStepGrid
                YStep = YStepGrid
            Case PlaneType.xz
                'XZ Rappresentation
                SpinScreenXAngle = 0
                SpinScreenYAngle = 90
                SpinScreenXSAngle = 0
                XScreenLabel = LabelXAxis
                YScreenLabel = LabelZAxis
                XStep = XStepGrid
                YStep = ZStepGrid
            Case PlaneType.yz
                'YZ Rappresentation
                SpinScreenXAngle = 0
                SpinScreenYAngle = 0
                SpinScreenXSAngle = 0
                XScreenLabel = LabelYAxis
                YScreenLabel = LabelZAxis
                XStep = YStepGrid
                YStep = ZStepGrid
            Case PlaneType.XYZ
        End Select
        
        'Set center of rotation for
        'rappresentation changing
        Xcenter = 0
        YCenter = 0
        ZCenter = 0
        'Calculate the area's dimension where to draw
        Drawing_Area
        'Check if a zoom has been done
        If tmpZoomExcursionX = 0 Then
             'Containers of properties of every shapes
             ReDim ArraySolids(NumberOfSolid - 1)
             'Filling of arrays for drawing
             For I = 1 To NumberOfSolid
                 For M = 1 To mSolids.Item(I).ShapesNumber
                     'Number of interpolated points of every shapes
                     ReDim Preserve ArraySolids(I - 1).DShapes(M - 1)
                     mSolids.Item(I).Shape(M).Draw Me
                     ArraySolids(I - 1).DShapes(M - 1).X() = mSolids.Item(I).Shape(M).XCoordinates
                     ArraySolids(I - 1).DShapes(M - 1).Y() = mSolids.Item(I).Shape(M).YCoordinates
                     ArraySolids(I - 1).DShapes(M - 1).Z() = mSolids.Item(I).Shape(M).ZCoordinates
                     ArraySolids(I - 1).DShapes(M - 1).Colour() = mSolids.Item(I).Shape(M).Colours
                     ArraySolids(I - 1).DShapes(M - 1).OPtsPointer() = mSolids.Item(I).Shape(M).Pointers
                     ArraySolids(I - 1).DShapes(M - 1).Marker() = mSolids.Item(I).Shape(M).Markers
                     ArraySolids(I - 1).DShapes(M - 1).MarkerSize() = mSolids.Item(I).Shape(M).MarkersSize
                     'If plot function is moving something
                     'keep fixed scale and previous minimum and maximal
                     'values
                     If m_MoveDeltaSelected = False And FixedScale = False Then
                         If UBound(ArraySolids(I - 1).DShapes(M - 1).Y()) = 0 And NumberOfSolid = 1 Then
                             'In case the shape is composit only
                             'by one point
                             tmpMaxy2 = ArraySolids(I - 1).DShapes(M - 1).Y(0) + 75
                             tmpMaxz2 = ArraySolids(I - 1).DShapes(M - 1).Z(0) + 75
                             tmpMiny2 = ArraySolids(I - 1).DShapes(M - 1).Y(0) - 75
                             tmpMinz2 = ArraySolids(I - 1).DShapes(M - 1).Z(0) - 75
                         Else
                             tmpMaxy2 = Find_Max_In_Array(ArraySolids(I - 1).DShapes(M - 1).Y())
                             tmpMaxz2 = Find_Max_In_Array(ArraySolids(I - 1).DShapes(M - 1).Z())
                             tmpMiny2 = Find_Min_In_Array(ArraySolids(I - 1).DShapes(M - 1).Y())
                             tmpMinz2 = Find_Min_In_Array(ArraySolids(I - 1).DShapes(M - 1).Z())
                         End If
                         'Check if it is first shape
                         If M = 1 Then
                             tmpMaxy1 = tmpMaxy2
                             tmpMaxz1 = tmpMaxz2
                             tmpMiny1 = tmpMiny2
                             tmpMinz1 = tmpMinz2
                         Else
                             tmpMaxy1 = Quick_Find_Max(tmpMaxy1, tmpMaxy2)
                             tmpMaxz1 = Quick_Find_Max(tmpMaxz1, tmpMaxz2)
                             tmpMiny1 = Quick_Find_Min(tmpMiny1, tmpMiny2)
                             tmpMinz1 = Quick_Find_Min(tmpMinz1, tmpMinz2)
                             tmpMaxy2 = tmpMaxy1
                             tmpMaxz2 = tmpMaxz1
                             tmpMiny2 = tmpMiny1
                             tmpMinz2 = tmpMinz1
                         End If
                     End If
                 Next M
                 'If plot function is moving something
                 'keep fixed scale and previous minimum and maximal
                 'values
                 If m_MoveDeltaSelected = False And FixedScale = False Then
                     'Check if it is first solid
                     If I = 1 Then
                         tmpPrevMaxy = tmpMaxy1
                         tmpPrevMaxz = tmpMaxz1
                         tmpPrevMiny = tmpMiny1
                         tmpPrevMinz = tmpMinz1
                     Else
                         tmpMaxy1 = Quick_Find_Max(tmpPrevMaxy, tmpMaxy1)
                         tmpMaxz1 = Quick_Find_Max(tmpPrevMaxz, tmpMaxz1)
                         tmpMiny1 = Quick_Find_Min(tmpPrevMiny, tmpMiny1)
                         tmpMinz1 = Quick_Find_Min(tmpPrevMinz, tmpMinz1)
                         tmpPrevMaxy = tmpMaxy1
                         tmpPrevMaxz = tmpMaxz1
                         tmpPrevMiny = tmpMiny1
                         tmpPrevMinz = tmpMinz1
                     End If
                 End If
             Next I
            If m_MoveDeltaSelected = True Or FixedScale Then
                tmpMaxy1 = tmpPrevMaxy
                tmpMaxz1 = tmpPrevMaxz
                tmpMiny1 = tmpPrevMiny
                tmpMinz1 = tmpPrevMinz
            End If
            'Conversion of excursions in pixels
            tmpExcursionX = ScaleX((tmpMaxy1 - tmpMiny1), vbMillimeters, vbPixels)
            tmpExcursionY = ScaleY((tmpMaxz1 - tmpMinz1), vbMillimeters, vbPixels)
        Else
           'This case is used when a zoom is been done
           'and then the user want to make a selection
            If FixedScale Then
                'Containers of properties of every shapes
                ReDim ArraySolids(NumberOfSolid - 1)
                For I = 1 To NumberOfSolid
                    For M = 1 To mSolids.Item(I).ShapesNumber
                        
                        'Number of interpolated points of every shapes
                        ReDim Preserve ArraySolids(I - 1).DShapes(M - 1)
                    
                        mSolids.Item(I).Shape(M).Draw Me
                     
                        ArraySolids(I - 1).DShapes(M - 1).X() = mSolids.Item(I).Shape(M).XCoordinates
                        ArraySolids(I - 1).DShapes(M - 1).Y() = mSolids.Item(I).Shape(M).YCoordinates
                        ArraySolids(I - 1).DShapes(M - 1).Z() = mSolids.Item(I).Shape(M).ZCoordinates
                        ArraySolids(I - 1).DShapes(M - 1).Colour() = mSolids.Item(I).Shape(M).Colours
                        ArraySolids(I - 1).DShapes(M - 1).OPtsPointer() = mSolids.Item(I).Shape(M).Pointers
                        ArraySolids(I - 1).DShapes(M - 1).Marker() = mSolids.Item(I).Shape(M).Markers
                        ArraySolids(I - 1).DShapes(M - 1).MarkerSize() = mSolids.Item(I).Shape(M).MarkersSize
                    
                    Next M
                
                Next I
            
                tmpMaxy1 = tmpPrevMaxy
                tmpMaxz1 = tmpPrevMaxz
                tmpMiny1 = tmpPrevMiny
                tmpMinz1 = tmpPrevMinz
    
            Else
            
                'This part is used when the user make a zoom
                tmpMaxy1 = tmpZoomMinX + ScaleX(tmpZoomExcursionX / SF, vbPixels, vbMillimeters)
                tmpMaxz1 = tmpZoomMinY + ScaleY(tmpZoomExcursionY / SF, vbPixels, vbMillimeters)
                tmpMiny1 = tmpZoomMinX
                tmpMinz1 = tmpZoomMinY
            
                tmpPrevMaxy = tmpMaxy1
                tmpPrevMaxz = tmpMaxz1
                tmpPrevMiny = tmpMiny1
                tmpPrevMinz = tmpMinz1
    
                tmpExcursionX = tmpZoomExcursionX / SF
                tmpExcursionY = tmpZoomExcursionY / SF
        
            End If
            
        End If
        
        
        'Check for fixed scale
        If FixedScale Then
        
            If m_ActiveMScale Then
                
                SF = PrevSF + m_ManualScale
                m_ActiveMScale = False
                m_ManualScale = 0
                
            Else
                
                'Set the scale factor to a fixed value
                SF = PrevSF
    
            End If
            
        Else
            
            If m_ActiveMScale Then
    
                'Add an offset
                SF = PrevSF + m_ManualScale
                m_ActiveMScale = False
                m_ManualScale = 0
                
            Else
                
                If Abs(tmpExcursionY) < 0.0001 Then tmpExcursionY = 150
                If Abs(tmpExcursionX) < 0.0001 Then tmpExcursionX = 150
                
                'Calculate scale factor
                SF = Scale_Factor(tmpExcursionX, tmpExcursionY, DrawingArea.Width, DrawingArea.Height)
            
            End If
    
        End If
        
        'Save new value
        PrevSF = SF

        'Offset of points to move in the Axis's center
        tmpCenterX = (DrawingArea.Left + (DrawingArea.Left + DrawingArea.Width)) / 2 - _
                     ScaleX(((tmpMaxy1 + tmpMiny1) / 2) * SF, vbMillimeters, vbPixels)
        
        tmpCenterY = ((ScaleTop - DrawingArea.Top) + (ScaleTop - (DrawingArea.Top + DrawingArea.Height))) / 2 - _
                     ScaleY(((tmpMaxz1 + tmpMinz1) / 2) * SF, vbMillimeters, vbPixels)
          
        
        'Update some values for mouse coordinates
        MinMouseX = (tmpMiny1 + tmpMaxy1) / 2 - ScaleX((DrawingArea.Width / 2 / SF), vbPixels, vbMillimeters)
        MinMouseY = (tmpMinz1 + tmpMaxz1) / 2 - ScaleY((DrawingArea.Height / 2 / SF), vbPixels, vbMillimeters)
        
        tmpMinGridX = MinMouseX
        tmpMinGridY = MinMouseY
        
        '***********************************************
        
        'Refresh Axis
        Cls
            
        For s = 1 To NumberOfSolid
            
            For I = 1 To mSolids.Item(s).ShapesNumber
                
                'Pointer to the next line with different color
                Prev = 0
            
                If mSolids.Item(s).Shape(I).Closed Then
                
                    EndPattern = mSolids.Item(s).Shape(I).PointsNumber
    
                    ReDim Preserve ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(EndPattern)
                    ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(EndPattern) = UBound(ArraySolids(s - 1).DShapes(I - 1).Y())
                    ReDim Preserve ArraySolids(s - 1).DShapes(I - 1).Colour(EndPattern)
                    ArraySolids(s - 1).DShapes(I - 1).Colour(EndPattern) = ArraySolids(s - 1).DShapes(I - 1).Colour(0)
                    ReDim Preserve ArraySolids(s - 1).DShapes(I - 1).Marker(EndPattern)
                    ArraySolids(s - 1).DShapes(I - 1).Marker(EndPattern) = ArraySolids(s - 1).DShapes(I - 1).Marker(0)
                    ReDim Preserve ArraySolids(s - 1).DShapes(I - 1).MarkerSize(EndPattern)
                    ArraySolids(s - 1).DShapes(I - 1).MarkerSize(EndPattern) = ArraySolids(s - 1).DShapes(I - 1).MarkerSize(0)
                
                Else
                
                    EndPattern = mSolids.Item(s).Shape(I).PointsNumber - 1
                
                End If
                
                'Draw shape
                For M = 0 To EndPattern
                    
                    'Check if property linecolour is setted in the shape
                    'or if the color of lines is decided by markers
                    If mSolids.Item(s).Shape(I).LineColour <> 0 Then
                    
                        'Update color
                        ForeColor = mSolids.Item(s).Shape(I).LineColour
            
                    Else
                        
                        'Update color
                        ForeColor = ArraySolids(s - 1).DShapes(I - 1).Colour(M)
                    
                    End If
                    
                    DrawStyle = mSolids.Item(s).Shape(I).LineStyle
                    DrawWidth = mSolids.Item(s).Shape(I).LineWidth
                   
                    Po = ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M) - Prev
                    'Dimension of ArrPts
                    ReDim ArrPts(Po)
                
                    'Fill array with coordinates of points
                    'with the same colors
                    For K = 0 To Po
                        
                        ArrPts(K).X = tmpCenterX + ScaleX((ArraySolids(s - 1).DShapes(I - 1).Y(Prev + K)) * SF, vbMillimeters, vbPixels)
                        'abs(ScaleHeight) is been added because PolyLine function is not sensible
                        'to the direction changing of Axis Y coordinate.It's as rotate the solid around half height
                        'of Axis
                        ArrPts(K).Y = Abs(ScaleHeight) - (tmpCenterY + (ScaleY((ArraySolids(s - 1).DShapes(I - 1).Z(Prev + K)) * SF, vbMillimeters, vbPixels)))
                                         
                    Next K
                
                    '****************************************
                    'ATTENTION:This point is create to draw a
                    'complete pattern (See Option Explicit in
                    'this module to find an explanation of
                    'PolyLine function)
                    '****************************************
                    If M = 0 Or M = EndPattern Then
                    
                        ReDim Preserve ArrPts(Po + 1)
                        ArrPts(Po + 1) = ArrPts(Po)
                        
                    End If
                   
                    'Discrimination of rappresentation
                    If mSolids.Item(s).Shape(I).RappresentationMode <> Marker Then
                                
                        MoveToEx Me.hdc, ArrPts(0).X, _
                                ArrPts(0).Y, ByVal 0&
                    
                        PolylineTo Me.hdc, ArrPts(0), Po + 1
                
                    End If
                
                    If (mSolids.Item(s).Shape(I).RappresentationMode <> Lines And mSolids.Item(s).Shape(I).RappresentationMode <> Spline) Or Trim(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) = "Selected" Then
                        'Settings of markers
                        ForeColor = ArraySolids(s - 1).DShapes(I - 1).Colour(M)
                        DrawStyle = ODrawStyle
                        DrawWidth = ODrawWidth
                        'Space cannot be rappresented
                        If Trim(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) = "o" Or (M = UBound(ArraySolids(s - 1).DShapes(I - 1).Marker()) And Trim(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) <> "Selected") Then
                            CurrentX = tmpCenterX + ScaleX(ArraySolids(s - 1).DShapes(I - 1).Y(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF
                            CurrentY = tmpCenterY + ScaleY(ArraySolids(s - 1).DShapes(I - 1).Z(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF
                            If M = UBound(ArraySolids(s - 1).DShapes(I - 1).Marker()) Then
                                Circle_ CurrentX, CurrentY, Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                                Circle_ CurrentX, CurrentY, 0.7 * Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                                Circle_ CurrentX, CurrentY, 0.5 * Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                                Circle_ CurrentX, CurrentY, 0.3 * Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                                Circle_ CurrentX, CurrentY, 0.1 * Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                            Else
                                Circle_ CurrentX, CurrentY, Val(ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M))
                            End If
                        ElseIf Trim(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) = "Selected" Then
                            CurrentX = tmpCenterX + ScaleX(ArraySolids(s - 1).DShapes(I - 1).Y(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2
                            CurrentY = tmpCenterY + ScaleY(ArraySolids(s - 1).DShapes(I - 1).Z(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2
                            Line_ CurrentX, CurrentY, CurrentX + (ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M)), CurrentY + (ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M)), vbBlack, True, True
                        ElseIf Trim(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) = "+" Then
                            CurrentX = tmpCenterX + ScaleX(ArraySolids(s - 1).DShapes(I - 1).Y(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF '- ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2
                            CurrentY = tmpCenterY + ScaleY(ArraySolids(s - 1).DShapes(I - 1).Z(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF '- ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2
                            Line_ CurrentX, CurrentY - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, CurrentX, CurrentY + ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, ArraySolids(s - 1).DShapes(I - 1).Colour(M)
                            Line_ CurrentX - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, CurrentY - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, CurrentX + ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, CurrentY - ArraySolids(s - 1).DShapes(I - 1).MarkerSize(M) / 2, ArraySolids(s - 1).DShapes(I - 1).Colour(M)
                        Else
                            CurrentX = tmpCenterX + ScaleX(ArraySolids(s - 1).DShapes(I - 1).Y(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF - TextWidth(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) / 2
                            CurrentY = tmpCenterY + ScaleY(ArraySolids(s - 1).DShapes(I - 1).Z(ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)), vbMillimeters, vbPixels) * SF - TextHeight(ArraySolids(s - 1).DShapes(I - 1).Marker(M)) / 2
                            Print_ ArraySolids(s - 1).DShapes(I - 1).Marker(M)
                        End If
                    End If
                    'Update color pointer
                    Prev = ArraySolids(s - 1).DShapes(I - 1).OPtsPointer(M)
                Next M
            Next I
        Next s
        'Setting original values
        ForeColor = OForeColor
        DrawStyle = ODrawStyle
        DrawWidth = ODrawWidth
        DrawWidth = 2
        
        'Tool Rappresentation when Shape.Identification = Sprayer
        For I = 1 To mSolids.Count
            
            For K = 1 To mSolids.Item(I).ShapesNumber
                
                If mSolids.Item(I).Shape(K).Identification = Sprayer And Plane <> XYZ Then
                    For M = 1 To mSolids.Item(I).Shape(K).PointsNumber
                        
                        'Calculating new OAT
                        GeomCalc.RotY 180, RFA()
                        GeomCalc.RotZ 0, RFT()
                        RFAT() = MMol(RFT(), RFA())
                        GeomCalc.RotZ mSolids.Item(I).Shape(K).Point(M).Orientation.First, RotO()
                        GeomCalc.RotY mSolids.Item(I).Shape(K).Point(M).Orientation.Second, RotA()
                        GeomCalc.RotZ mSolids.Item(I).Shape(K).Point(M).Orientation.Third, RotT()
                        ROA() = MMol(RotO(), RotA())
                        ROAT() = MMol(ROA(), RotT())
                        RFOAT() = MMol(RFAT(), ROAT())
                        GeomCalc.RotX -mSolids.Item(I).Shape(K).Point(M).OffsetOrientation.First, RotX()
                        GeomCalc.RotY mSolids.Item(I).Shape(K).Point(M).OffsetOrientation.Second, RotY()
                        GeomCalc.RotZ -mSolids.Item(I).Shape(K).Point(M).OffsetOrientation.Third, RotZ()
                        RZY() = MMol(RotZ(), RotY())
                        RZYX() = MMol(RZY(), RotX())
                        RTot() = MMol(RZYX(), RFOAT())
                        NewZYXAngles.AngleType = "ZYX"
                        GeomCalc.GetPointByTrans RTot(), Origin, NewZYXAngles
                        CenterMatrix(1, 1) = mSolids.Item(I).Shape(K).Point(M).X
                        CenterMatrix(2, 1) = mSolids.Item(I).Shape(K).Point(M).Y
                        CenterMatrix(3, 1) = mSolids.Item(I).Shape(K).Point(M).Z
                        CenterMatrix(4, 1) = 1
                        CoordPointTemp(1, 1) = mSolids.Item(I).Shape(K).Point(M).X
                        CoordPointTemp(2, 1) = mSolids.Item(I).Shape(K).Point(M).Y
                        CoordPointTemp(3, 1) = mSolids.Item(I).Shape(K).Point(M).Z + 15 / SF
                        CoordPointTemp(4, 1) = 1
                        CoordPointTempTool(1, 1) = mSolids.Item(I).Shape(K).Point(M).X
                        CoordPointTempTool(2, 1) = mSolids.Item(I).Shape(K).Point(M).Y - 7
                        CoordPointTempTool(3, 1) = mSolids.Item(I).Shape(K).Point(M).Z + 15 / SF
                        CoordPointTempTool(4, 1) = 1

                        Difference() = MDif(CoordPointTemp(), CenterMatrix())
                        Difference(4, 1) = 1
                        DifferenceTool() = MDif(CoordPointTempTool(), CenterMatrix())
                        DifferenceTool(4, 1) = 1

                        'Coordinates of point rotated
                        RotatePointTemp() = MMol(RTot(), Difference())
                        Add() = MSom(RotatePointTemp(), CenterMatrix())
                        RotatePointTempTool() = MMol(RTot(), DifferenceTool())
                        AddTool() = MSom(RotatePointTempTool(), CenterMatrix())
                        
                        Select Case Plane
                            Case xy
                                'Update the coordinates
                                LineEndX = Add(1, 1)
                                LineEndY = Add(2, 1) - 2 * RotatePointTemp(2, 1)
                                LineStartX = mSolids.Item(I).Shape(K).Point(M).X
                                LineStartY = mSolids.Item(I).Shape(K).Point(M).Y
                                LineEndXTool = AddTool(1, 1)
                                LineEndYTool = AddTool(2, 1) - 2 * RotatePointTempTool(2, 1)
                                LineStartXTool = LineEndX
                                LineStartYTool = LineEndY
                            Case xz
                                'Update the coordinates
                                LineEndX = Add(1, 1)
                                LineEndY = Add(3, 1)
                                LineStartX = mSolids.Item(I).Shape(K).Point(M).X
                                LineStartY = mSolids.Item(I).Shape(K).Point(M).Z
                                LineEndXTool = AddTool(1, 1)
                                LineEndYTool = AddTool(3, 1)
                                LineStartXTool = LineEndX
                                LineStartYTool = LineEndY
                            Case yz
                                'Update the coordinates
                                LineEndX = Add(2, 1)
                                LineEndY = Add(3, 1)
                                LineStartX = mSolids.Item(I).Shape(K).Point(M).Y
                                LineStartY = mSolids.Item(I).Shape(K).Point(M).Z
                                LineEndXTool = AddTool(2, 1)
                                LineEndYTool = AddTool(3, 1)
                                LineStartXTool = LineEndX
                                LineStartYTool = LineEndY
                            Case XYZ
                                'Update the coordinates
                                LineEndX = Add(1, 1)
                                LineEndY = Add(2, 1) - 2 * RotatePointTemp(2, 1)
                                LineStartX = mSolids.Item(I).Shape(K).Point(M).X
                                LineStartY = mSolids.Item(I).Shape(K).Point(M).Y
                                LineEndXTool = AddTool(1, 1)
                                LineEndYTool = AddTool(2, 1) - 2 * RotatePointTempTool(2, 1)
                                LineStartXTool = LineEndX
                                LineStartYTool = LineEndY
                        End Select
                        LineStartX = tmpCenterX + ScaleX(LineStartX, vbMillimeters, vbPixels) * SF
                        If LineStartX < 0.00001 Then LineStartX = 0.00001
                        LineStartY = tmpCenterY + ScaleY(LineStartY, vbMillimeters, vbPixels) * SF
                        If LineStartY < 0.00001 Then LineStartX = 0.00001
                        LineEndX = tmpCenterX + ScaleX(LineEndX, vbMillimeters, vbPixels) * SF
                        If LineEndX < 0.00001 Then LineStartX = 0.00001
                        LineEndY = tmpCenterY + ScaleY(LineEndY, vbMillimeters, vbPixels) * SF
                        If LineEndY < 0.00001 Then LineStartX = 0.00001
                        LineStartXTool = LineEndX
                        If LineStartXTool < 0.00001 Then LineStartX = 0.00001
                        LineStartYTool = LineEndY
                        If LineStartYTool < 0.00001 Then LineStartX = 0.00001
                        LineEndXTool = tmpCenterX + ScaleX(LineEndXTool, vbMillimeters, vbPixels) * SF
                        If LineEndXTool < 0.00001 Then LineStartX = 0.00001
                        LineEndYTool = tmpCenterY + ScaleY(LineEndYTool, vbMillimeters, vbPixels) * SF
                        If LineEndYTool < 0.00001 Then LineStartX = 0.00001
                        
                        
                        If mSolids.Item(I).Shape(K).Point(M).ToolNumber = 1 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbGreen
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ', &HFFC0FF
                        ElseIf mSolids.Item(I).Shape(K).Point(M).ToolNumber = 2 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbRed
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ', &HFFC0FF
                        ElseIf mSolids.Item(I).Shape(K).Point(M).ToolNumber = 3 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbBlue
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ' &HFFC0FF
                        ElseIf mSolids.Item(I).Shape(K).Point(M).ToolNumber = 4 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbBlack
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ', &HFFC0FF
                        ElseIf mSolids.Item(I).Shape(K).Point(M).ToolNumber = 5 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbMagenta
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ', &HFFC0FF
                        ElseIf mSolids.Item(I).Shape(K).Point(M).ToolNumber = 6 Then
                            Line_ LineStartX, LineStartY, LineEndX, LineEndY, vbCyan
                            Line_ LineEndX, LineEndY, LineEndXTool, LineEndYTool, RGB(160, 16, 256) ', &HFFC0FF
                        End If
                        If mSolids.Item(I).Shape(K).Point(M).Procedure = 0 Then
                            'No Procedure
                            Print_ ""
                        ElseIf mSolids.Item(I).Shape(K).Point(M).Procedure = 1 Then
                            'Open Sprayer Procedure
                            Print_ "  Apri "
                        ElseIf mSolids.Item(I).Shape(K).Point(M).Procedure = 2 Then
                            'Close Sprayer Procedure
                            Print_ "  Chiudi "
                        ElseIf mSolids.Item(I).Shape(K).Point(M).Procedure = 3 Then
                            'Stop Sprayer Procedure
                            Print_ "  Stop "
                        End If
                    Next M
                End If
            Next K
        Next I
        'Setting original values
        ForeColor = OForeColor
        DrawStyle = ODrawStyle
        DrawWidth = ODrawWidth
        'Clean the area over drawing area limits
        Clean_Border_Area
        Drawing_Grid_2D tmpMinGridX, tmpMinGridY, XScreenLabel, YScreenLabel, XStep, YStep
    Else
        Cls
    End If
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4
Public Function SpinXScreen() As Double

End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=4
Public Function SpinYScreen() As Double

End Function

'Inizializza le propriet di UserControl.
Private Sub UserControl_InitProperties()
    
    Set UserControl.Font = Ambient.Font
    m_SpinScreenXAngle = m_def_SpinScreenXAngle
    m_SpinScreenYAngle = m_def_SpinScreenYAngle
    m_Plane = m_def_Plane
    m_NumberOfSolid = m_def_NumberOfSolid
    m_Hold = m_def_Hold
    m_Selected = m_def_Selected
    m_Zoomed = m_def_Zoomed
    m_UnZoomed = m_def_UnZoomed
    m_XCenter = m_def_XCenter
    m_YCenter = m_def_YCenter
    m_ZCenter = m_def_ZCenter
    m_Saved = m_def_Saved
    m_Grid = m_def_Grid
    m_MousePointer = m_def_MousePointer

    m_OBorderLeft = m_def_OBorderLeft
    m_OBorderRight = m_def_OBorderRight
    m_OBorderTop = m_def_OBorderTop
    m_OBorderBottom = m_def_OBorderBottom
    m_XStepGrid = m_def_XStepGrid
    m_YStepGrid = m_def_YStepGrid
    m_ZStepGrid = m_def_ZStepGrid
    m_LabelXAxis = m_def_LabelXAxis
    m_LabelYAxis = m_def_LabelYAxis
    m_LabelZAxis = m_def_LabelZAxis
    m_FigureTitle = m_def_FigureTitle
    m_FixedScale = m_def_FixedScale
    m_BorderFactor = m_def_BorderFactor
'    m_ScaledMouseY = m_def_ScaledMouseY
    m_ScaledMouseX = m_def_ScaledMouseX
    m_ScaledMouseY = m_def_ScaledMouseY
    m_Applications = m_def_Applications
    
End Sub

'Carica i valori delle propriet dalla posizione di memorizzazione.
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    
    UserControl.MousePointer = PropBag.ReadProperty("MousePointer", m_def_MousePointer)
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000F)
    UserControl.ForeColor = PropBag.ReadProperty("ForeColor", &H80000012)
    Set UserControl.Font = PropBag.ReadProperty("Font", Ambient.Font)
    UserControl.BackStyle = PropBag.ReadProperty("BackStyle", 1)
    UserControl.BorderStyle = PropBag.ReadProperty("BorderStyle", 0)
    UserControl.AutoRedraw = PropBag.ReadProperty("AutoRedraw", False)
    UserControl.Appearance = PropBag.ReadProperty("Appearance", 1)
    UserControl.CurrentX = PropBag.ReadProperty("CurrentX", 0)
    UserControl.CurrentY = PropBag.ReadProperty("CurrentY", 0)
    UserControl.DrawMode = PropBag.ReadProperty("DrawMode", 13)
    UserControl.DrawStyle = PropBag.ReadProperty("DrawStyle", 0)
    UserControl.DrawWidth = PropBag.ReadProperty("DrawWidth", 1)
    UserControl.FillColor = PropBag.ReadProperty("FillColor", &H0&)
    UserControl.FillStyle = PropBag.ReadProperty("FillStyle", 1)
    UserControl.FontBold = PropBag.ReadProperty("FontBold", 0)
    UserControl.FontItalic = PropBag.ReadProperty("FontItalic", 0)
    UserControl.FontName = PropBag.ReadProperty("FontName", "MS Sans Serif")
    UserControl.FontSize = PropBag.ReadProperty("FontSize", 8)
    UserControl.FontStrikethru = PropBag.ReadProperty("FontStrikethru", 0)
    UserControl.FontTransparent = PropBag.ReadProperty("FontTransparent", True)
    UserControl.FontUnderline = PropBag.ReadProperty("FontUnderline", 0)
    'UserControl.ScaleHeight = PropBag.ReadProperty("ScaleHeight", 3600)
    UserControl.ScaleLeft = PropBag.ReadProperty("ScaleLeft", 0)
    UserControl.ScaleMode = PropBag.ReadProperty("ScaleMode", 1)
    UserControl.ScaleTop = PropBag.ReadProperty("ScaleTop", 0)
'    UserControl.ScaleWidth = PropBag.ReadProperty("ScaleWidth", 4800)
    m_SpinScreenXAngle = PropBag.ReadProperty("SpinScreenXAngle", m_def_SpinScreenXAngle)
    m_SpinScreenYAngle = PropBag.ReadProperty("SpinScreenYAngle", m_def_SpinScreenYAngle)
    m_Plane = PropBag.ReadProperty("Plane", m_def_Plane)
    m_NumberOfSolid = PropBag.ReadProperty("NumberOfSolid", m_def_NumberOfSolid)
    m_Hold = PropBag.ReadProperty("Hold", m_def_Hold)
    m_Selected = PropBag.ReadProperty("Selected", m_def_Selected)
    m_Zoomed = PropBag.ReadProperty("Zoomed", m_def_Zoomed)
    m_UnZoomed = PropBag.ReadProperty("Zoomed", m_def_UnZoomed)
    m_XCenter = PropBag.ReadProperty("XCenter", m_def_XCenter)
    m_YCenter = PropBag.ReadProperty("YCenter", m_def_YCenter)
    m_ZCenter = PropBag.ReadProperty("ZCenter", m_def_ZCenter)
    m_Saved = PropBag.ReadProperty("Saved", m_def_Saved)
    m_Grid = PropBag.ReadProperty("Grid", m_def_Grid)
    m_OBorderLeft = PropBag.ReadProperty("OBorderLeft", m_def_OBorderLeft)
    m_OBorderRight = PropBag.ReadProperty("OBorderRight", m_def_OBorderRight)
    m_OBorderTop = PropBag.ReadProperty("OBorderTop", m_def_OBorderTop)
    m_OBorderBottom = PropBag.ReadProperty("OBorderBottom", m_def_OBorderBottom)
    m_XStepGrid = PropBag.ReadProperty("XStepGrid", m_def_XStepGrid)
    m_YStepGrid = PropBag.ReadProperty("YStepGrid", m_def_YStepGrid)
    m_ZStepGrid = PropBag.ReadProperty("ZStepGrid", m_def_ZStepGrid)
    m_LabelXAxis = PropBag.ReadProperty("LabelXAxis", m_def_LabelXAxis)
    m_LabelYAxis = PropBag.ReadProperty("LabelYAxis", m_def_LabelYAxis)
    m_LabelZAxis = PropBag.ReadProperty("LabelZAxis", m_def_LabelZAxis)
    m_FigureTitle = PropBag.ReadProperty("FigureTitle", m_def_FigureTitle)
    Set Picture = PropBag.ReadProperty("Picture", Nothing)
    m_FixedScale = PropBag.ReadProperty("FixedScale", m_def_FixedScale)
    m_BorderFactor = PropBag.ReadProperty("BorderFactor", m_def_BorderFactor)
    m_ScaledMouseX = PropBag.ReadProperty("ScaledMouseX", m_def_ScaledMouseX)
    m_ScaledMouseY = PropBag.ReadProperty("ScaledMouseY", m_def_ScaledMouseY)
    m_Applications = PropBag.ReadProperty("Application", m_def_Applications)

    Set MouseIcon = PropBag.ReadProperty("MouseIcon", Nothing)
End Sub

Private Sub UserControl_Terminate()
    Set mSolids = Nothing
End Sub

'Scrive i valori delle propriet nella posizione di memorizzazione.
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("MousePointer", UserControl.MousePointer, m_def_MousePointer)
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000F)
    Call PropBag.WriteProperty("ForeColor", UserControl.ForeColor, &H80000012)
    Call PropBag.WriteProperty("Font", UserControl.Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", UserControl.BackStyle, 1)
    Call PropBag.WriteProperty("BorderStyle", UserControl.BorderStyle, 0)
    Call PropBag.WriteProperty("AutoRedraw", UserControl.AutoRedraw, False)
    Call PropBag.WriteProperty("Appearance", UserControl.Appearance, 1)
    Call PropBag.WriteProperty("CurrentX", UserControl.CurrentX, 0)
    Call PropBag.WriteProperty("CurrentY", UserControl.CurrentY, 0)
    Call PropBag.WriteProperty("DrawMode", UserControl.DrawMode, 13)
    Call PropBag.WriteProperty("DrawStyle", UserControl.DrawStyle, 0)
    Call PropBag.WriteProperty("DrawWidth", UserControl.DrawWidth, 1)
    Call PropBag.WriteProperty("FillColor", UserControl.FillColor, &H0&)
    Call PropBag.WriteProperty("FillStyle", UserControl.FillStyle, 1)
    Call PropBag.WriteProperty("FontBold", UserControl.FontBold, 0)
    Call PropBag.WriteProperty("FontItalic", UserControl.FontItalic, 0)
    Call PropBag.WriteProperty("FontName", UserControl.FontName, "")
    Call PropBag.WriteProperty("FontSize", UserControl.FontSize, 0)
    Call PropBag.WriteProperty("FontStrikethru", UserControl.FontStrikethru, 0)
    Call PropBag.WriteProperty("FontTransparent", UserControl.FontTransparent, True)
    Call PropBag.WriteProperty("FontUnderline", UserControl.FontUnderline, 0)
    Call PropBag.WriteProperty("ScaleHeight", UserControl.ScaleHeight, 3600)
    Call PropBag.WriteProperty("ScaleLeft", UserControl.ScaleLeft, 0)
    Call PropBag.WriteProperty("ScaleMode", UserControl.ScaleMode, 1)
    Call PropBag.WriteProperty("ScaleTop", UserControl.ScaleTop, 0)
    Call PropBag.WriteProperty("ScaleWidth", UserControl.ScaleWidth, 4800)
    Call PropBag.WriteProperty("SpinScreenXAngle", m_SpinScreenXAngle, m_def_SpinScreenXAngle)
    Call PropBag.WriteProperty("SpinScreenYAngle", m_SpinScreenYAngle, m_def_SpinScreenYAngle)
    Call PropBag.WriteProperty("Plane", m_Plane, m_def_Plane)
    Call PropBag.WriteProperty("NumberOfSolid", m_NumberOfSolid, m_def_NumberOfSolid)
    Call PropBag.WriteProperty("Hold", m_Hold, m_def_Hold)
    Call PropBag.WriteProperty("Selected", m_Selected, m_def_Selected)
    Call PropBag.WriteProperty("Zoomed", m_Zoomed, m_def_Zoomed)
    Call PropBag.WriteProperty("Zoomed", m_UnZoomed, m_def_UnZoomed)
    Call PropBag.WriteProperty("XCenter", m_XCenter, m_def_XCenter)
    Call PropBag.WriteProperty("YCenter", m_YCenter, m_def_YCenter)
    Call PropBag.WriteProperty("ZCenter", m_ZCenter, m_def_ZCenter)
    Call PropBag.WriteProperty("Saved", m_Saved, m_def_Saved)
    Call PropBag.WriteProperty("Grid", m_Grid, m_def_Grid)
    Call PropBag.WriteProperty("OBorderLeft", m_OBorderLeft, m_def_OBorderLeft)
    Call PropBag.WriteProperty("OBorderRight", m_OBorderRight, m_def_OBorderRight)
    Call PropBag.WriteProperty("OBorderTop", m_OBorderTop, m_def_OBorderTop)
    Call PropBag.WriteProperty("OBorderBottom", m_OBorderBottom, m_def_OBorderBottom)
    Call PropBag.WriteProperty("XStepGrid", m_XStepGrid, m_def_XStepGrid)
    Call PropBag.WriteProperty("YStepGrid", m_YStepGrid, m_def_YStepGrid)
    Call PropBag.WriteProperty("ZStepGrid", m_ZStepGrid, m_def_ZStepGrid)
    Call PropBag.WriteProperty("LabelXAxis", m_LabelXAxis, m_def_LabelXAxis)
    Call PropBag.WriteProperty("LabelYAxis", m_LabelYAxis, m_def_LabelYAxis)
    Call PropBag.WriteProperty("LabelZAxis", m_LabelZAxis, m_def_LabelZAxis)
    Call PropBag.WriteProperty("FigureTitle", m_FigureTitle, m_def_FigureTitle)
    Call PropBag.WriteProperty("Picture", Picture, Nothing)
    Call PropBag.WriteProperty("FixedScale", m_FixedScale, m_def_FixedScale)
    Call PropBag.WriteProperty("BorderFactor", m_BorderFactor, m_def_BorderFactor)
'    Call PropBag.WriteProperty("ScaledMouseY", m_ScaledMouseY, m_def_ScaledMouseY)
    Call PropBag.WriteProperty("Application", m_Applications, m_def_Applications)
    Call PropBag.WriteProperty("MouseIcon", MouseIcon, Nothing)
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=14
Public Function Print_(ByVal Expression As String)
    UserControl.Print Expression
End Function

Public Sub AddSolids(ByVal NewMember As InBlu_Solid, Optional lKey As Long)
'Function to add a shape to shapes collection
'INPUT PARAMETER:
'               NewMember:New shape added
'               Lkey:Number to indicate the position of shape
    If lKey <= 1 Then
        mSolids.Add NewMember
    Else
        'Add new point in the specified position
        mSolids.Add NewMember, , lKey
    End If
End Sub

Public Sub RemoveSolids(Optional lKey As Long = 1)
'Function to remove shape from the collection
'INPUT PARAMETER:
'               lKey:Index of shape to remove
    'Remove point
    mSolids.Remove lKey
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MappingInfo=UserControl,UserControl,-1,Line
Public Sub Line_(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal Color As Long, _
                Optional ByVal B As Boolean, Optional ByVal f As Boolean)
    If B And Not (f) Then
        UserControl.Line (X1, Y1)-(X2, Y2), Color, B
    ElseIf B And f Then
        UserControl.Line (X1, Y1)-(X2, Y2), Color, BF
    Else
        UserControl.Line (X1, Y1)-(X2, Y2), Color
    End If
End Sub

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=14
Public Function LoadFile(ByVal FileRead As String, ByVal Hold As Boolean) As Boolean

    'Declarations
    Dim TmpTrans As New InBlu_Translator
    Dim I As Long, tmpSolid() As InBlu_Solid
    Dim Find_Error As Boolean
    
    tmpSolid() = TmpTrans.Read_File(FileRead, Find_Error)
    
    If Find_Error = False Then
       If Hold = False Then
            Set mSolids = Nothing
            Set mSolids = New Collection
           'Reset manual variation of scale
            'when a new figure is loaded
            m_ManualScale = 0
        End If
        For I = LBound(tmpSolid()) To UBound(tmpSolid())
            mSolids.Add tmpSolid(I)
        Next I
        FixedScale = False
        Plot
    End If
    LoadFile = Find_Error
End Function

'AVVISO: NON RIMUOVERE O MODIFICARE LE SEGUENTI RIGHE DI COMMENTO
'MemberInfo=14
Public Function SaveFile(ByVal FileWrite As String)

    'Declarations
    Dim TmpTrans As New InBlu_Translator
    
    mSolids.Item(1).Saveable = True
    TmpTrans.Write_File FileWrite, mSolids
End Function

Private Sub Drawing_Area()

    'Declarations
    Static PrevDA As D_AREA

    'Check if fixedscale property is activate
    If FixedScale Then
        With PrevDA
            .Left = DrawingArea.Left
            .Top = DrawingArea.Top
            .Height = DrawingArea.Height
            .Width = DrawingArea.Width
        End With
    Else
        'Coordinates of Drawing Area
        DrawingArea.Left = OBorderLeft
        DrawingArea.Width = Abs(ScaleWidth) - OBorderRight - OBorderLeft
        DrawingArea.Top = OBorderTop
        DrawingArea.Height = Abs(ScaleHeight) - OBorderBottom - OBorderTop
        PrevDA.Left = DrawingArea.Left
        PrevDA.Top = DrawingArea.Top
        PrevDA.Height = DrawingArea.Height
        PrevDA.Width = DrawingArea.Width
    End If
End Sub

Private Sub Drawing_Grid_2D(ByVal MinimumX As Double, ByVal MinimumY As Double, _
                            ByVal XScreenLabel As String, ByVal YScreenLabel As String, ByVal XStep As Double, _
                            ByVal YStep As Double)

    'Declarations
    Dim VarStack As Single, I As Long
    Dim Character As String * 1
    Dim XTickLabelHeight As Double, YTickLabelWidth As Double
    Dim MAX As Long, ActiveGrid As Boolean
    Dim XValue As Double, YValue As Double
    Dim OLineX As Double, OLineY As Double, ELineX As Double, ElineY As Double
    Dim OFontSize As Long
    Dim tmpXStep As Long, tmpYStep As Long
    Dim TmpTitle As String
    
    'Change the dimension of font
    OFontSize = Font.Size
    Font.Size = 8
   'Set some values for other function
    XTickLabelHeight = Abs(TextHeight("W"))
    OLineX = ScaleLeft + DrawingArea.Left + DrawingArea.Width
    OLineY = ScaleTop - DrawingArea.Top
    ELineX = ScaleLeft + DrawingArea.Left + DrawingArea.Width
    ElineY = ScaleTop - DrawingArea.Top - DrawingArea.Height
    Line_ OLineX, OLineY, ELineX, ElineY, &HC0C0C0
    tmpXStep = ScaleX((XStep * SF), vbMillimeters, vbPixels)
    'Number of columns
    MAX = Fix(DrawingArea.Width / tmpXStep)
    'Draw columns
    For I = 0 To MAX
        'Set the coordinates of a line
        OLineX = ScaleLeft + DrawingArea.Left + (tmpXStep * I)
        OLineY = ScaleTop - DrawingArea.Top
        ELineX = ScaleLeft + DrawingArea.Left + (tmpXStep * I)
        ElineY = ScaleTop - DrawingArea.Top - DrawingArea.Height
        If I > 0 Then
            If Grid Then
            'All columns except Axis Y have this style
                DrawStyle = 2
            Else
                DrawStyle = 5
            End If
        End If
        Line_ OLineX, OLineY, ELineX, ElineY, &HC0C0C0
        XValue = CDbl(Format(MinimumX + ScaleX((I * tmpXStep) / SF, vbPixels, vbMillimeters), "Fixed"))
        CurrentX = CurrentX - (TextWidth(Str(Format(XValue, "Fixed")))) / 2
        Print Str(XValue)
    Next I
    DrawStyle = 0
    OLineX = ScaleLeft + DrawingArea.Left + DrawingArea.Width
    OLineY = ScaleTop - DrawingArea.Top
    ELineX = ScaleLeft + DrawingArea.Left
    ElineY = ScaleTop - DrawingArea.Top
    Line_ OLineX, OLineY, ELineX, ElineY, &HC0C0C0
    tmpYStep = ScaleY(YStep * SF, vbMillimeters, vbPixels)
    'Number of rows
    MAX = Fix(DrawingArea.Height / tmpYStep)
    'Draw rows
    For I = 0 To MAX
        'Set the coordinates of a line
        OLineX = ScaleLeft + DrawingArea.Left + DrawingArea.Width
        OLineY = ScaleTop - DrawingArea.Top - DrawingArea.Height + (tmpYStep * I)
        ELineX = ScaleLeft + DrawingArea.Left
        ElineY = ScaleTop - DrawingArea.Top - DrawingArea.Height + (tmpYStep * I)
        If I > 0 Then
            If Grid Then
                'All rows except Axis X have this style
                DrawStyle = 2
            Else
                DrawStyle = 5
            End If
        Else
            'Axis X
            DrawStyle = 0
        End If
        Line_ OLineX, OLineY, ELineX, ElineY, &HC0C0C0
        YValue = CDbl(Format(MinimumY + ScaleY((I * tmpYStep) / SF, vbPixels, vbMillimeters), "Fixed"))
        'Is been added a zero to center the label of Y screen axis
        YTickLabelWidth = TextWidth("000.000")
        CurrentY = CurrentY - TextHeight("W")
        CurrentX = CurrentX - TextWidth(Str(Format(YValue, "Fixed")))
        Print Str(YValue)
    Next I
    DrawStyle = 0
    Font.Size = 8
    'X Labels
    'Height of label
    VarStack = TextHeight(Str(XValue))
    'This coordinate is composite by: (Origin of Y axe + Bottom Border - Label Height )/2
    CurrentY = (ScaleTop + ScaleHeight) + (((ScaleTop - (DrawingArea.Top + DrawingArea.Height)) - XTickLabelHeight) - VarStack) / 2
    CurrentX = ScaleLeft + DrawingArea.Left + (DrawingArea.Width - TextWidth(XScreenLabel)) / 2
    Print XScreenLabel
    'Y Labels
    CurrentY = (ScaleTop + ScaleHeight) + (ScaleTop - (DrawingArea.Top + DrawingArea.Height)) + _
            (DrawingArea.Height - TextHeight(Character) * Len(YScreenLabel)) / 2
    VarStack = DrawingArea.Left - YTickLabelWidth
    For I = 1 To Len(YScreenLabel)
        Character = Mid$(YScreenLabel, I, 1)
        CurrentX = ScaleLeft + (VarStack - TextWidth(Character)) / 2
        Print Character
    Next I
    'Title
    Font.Size = 12
    Font.Bold = True
    'Center title
    CurrentX = ScaleLeft + DrawingArea.Left + (DrawingArea.Width - TextWidth(FigureTitle)) / 2
    VarStack = TextHeight(FigureTitle)
    CurrentY = (ScaleTop + ScaleHeight) + (ScaleTop - (DrawingArea.Top + DrawingArea.Height)) + _
                DrawingArea.Height + (ScaleTop - DrawingArea.Height - (ScaleTop - _
                (DrawingArea.Top + DrawingArea.Height)) - VarStack) / 2
    Print FigureTitle
    Font.Bold = False
    Font.Size = OFontSize
End Sub

Public Sub ManualScale(ByVal Data As Double)
'Can set an offset to increase or decrease the scale
'factor manually.
'INPUT PARAMETER:
'               Data:Value of offset
    m_ManualScale = m_ManualScale + Data
    m_ActiveMScale = True
    If PrevSF < 0.1 And Data < 0 Then
        m_ManualScale = 0
    End If
End Sub

Public Sub ChangeRappresentation(ByVal NewRappresentation As Style)
'This method change the rappresentation style of selected shapes
'INPUT PARAMETER:
'               NewRappresentation: Type of rappresentation

    'Declarations
    Dim I As Long
    
    For I = 0 To UBound(SelectedObject())
        If SelectedObject(I).TypeID = ShapesType Or SelectedObject(I).TypeID = MultiShapeType Then
            mSolids.Item(SelectedObject(I).SolidID).Shape(SelectedObject(I).ShapeID).RappresentationMode = NewRappresentation
        End If
    Next I
End Sub


Private Sub Clean_Border_Area()

    'Declarations
    Dim OForeColor As Long
    Dim hbrush As Long ' riceve l' handle per l'oggetto brush giallo
    Dim holdbrush As Long ' riceve l'handle dell'oggetto brush precedente
    Dim retval As Long ' valore di ritorno
    
    OForeColor = ForeColor
    ForeColor = vbWhite
    hbrush = CreateSolidBrush(RGB(255, 255, 255)) ' Crea l'oggetto per dipingere
    ' Memorizza il brush precedente affinch possa essere ripristinato al termine del programma
    holdbrush = SelectObject(hdc, hbrush)
    ' Disegna un rettangolo utilizzando il brush giallo appena creato.
    retval = Rectangle(hdc, ScaleLeft, ScaleTop + ScaleHeight, ScaleLeft + ScaleWidth, ScaleTop + ScaleHeight + OBorderTop)
    ' Ripristina il precedente Brush
    retval = SelectObject(hdc, holdbrush) ' seleziona old brush
    retval = DeleteObject(hbrush) ' distrugge il brush giallo
    hbrush = CreateSolidBrush(RGB(255, 255, 255)) ' Crea l'oggetto per dipingere
    ' Memorizza il brush precedente affinch possa essere ripristinato al termine del programma
    holdbrush = SelectObject(hdc, hbrush)
    ' Disegna un rettangolo utilizzando il brush giallo appena creato.
    retval = Rectangle(hdc, ScaleLeft, ScaleTop - OBorderBottom, ScaleLeft + ScaleWidth, ScaleTop)
    ' Ripristina il precedente Brush
    retval = SelectObject(hdc, holdbrush) ' seleziona old brush
    retval = DeleteObject(hbrush) ' distrugge il brush giallo
    hbrush = CreateSolidBrush(RGB(255, 255, 255)) ' Crea l'oggetto per dipingere
    ' Memorizza il brush precedente affinch possa essere ripristinato al termine del programma
    holdbrush = SelectObject(hdc, hbrush)
    ' Disegna un rettangolo utilizzando il brush giallo appena creato.
    retval = Rectangle(hdc, ScaleLeft, ScaleTop, ScaleLeft + OBorderLeft, ScaleTop + ScaleHeight)
    ' Ripristina il precedente Brush
    retval = SelectObject(hdc, holdbrush) ' seleziona old brush
    retval = DeleteObject(hbrush) ' distrugge il brush giallo
    hbrush = CreateSolidBrush(RGB(255, 255, 255)) ' Crea l'oggetto per dipingere
    ' Memorizza il brush precedente affinch possa essere ripristinato al termine del programma
    holdbrush = SelectObject(hdc, hbrush)
    ' Disegna un rettangolo utilizzando il brush giallo appena creato.
    retval = Rectangle(hdc, ScaleLeft + ScaleWidth - OBorderRight, ScaleTop, ScaleLeft + ScaleWidth, ScaleTop + ScaleHeight)
    ' Ripristina il precedente Brush
    retval = SelectObject(hdc, holdbrush) ' seleziona old brush
    retval = DeleteObject(hbrush) ' distrugge il brush giallo
    ForeColor = OForeColor
End Sub

Private Sub Activate_Zoom(ByVal tmpX As Double, ByVal tmpY As Double)
'Function that start zoom procedure
    'Save mouse coordinates
    OX = tmpX
    OY = tmpY
    ZoomProcedure = True
    'Active Zoom Area
    shpZoomArea.Width = 1
    shpZoomArea.Height = 1
    shpZoomArea.Visible = True
    shpZoomArea.BackStyle = 0
End Sub

Private Function Find_Selected(ByVal tmpX As Double, ByVal tmpY As Double) As Boolean

    'Declarations
    Dim I As Long, M As Long, K As Long, Q As Long, r As Long
    Dim SolidsSelected() As Long, ShapesSelected() As Long
    Dim PointsSelected() As Long, Types() As Functions
    Dim tmpSelectedObject1 As FindOnScreen
    Dim tmpSelectedObject2 As FindOnScreen
    Dim tmpDist As Double
    Dim tmpRemoved As Boolean
    Dim Actions As SelectAction
    
    'Click only left button to choose a point
    For I = 1 To NumberOfSolid
        tmpSelectedObject1.SolidID = I
        For r = 1 To mSolids.Item(I).ShapesNumber
            tmpSelectedObject1.ShapeID = r
            'Find the point most near to mouse click point
            mSolids.Item(I).Shape(r).GetNearestPoint tmpX, tmpY, Plane, tmpSelectedObject1.PointID, tmpSelectedObject1.Dist
            If r = 1 And I = 1 Then
                tmpSelectedObject2 = tmpSelectedObject1
            Else
                tmpDist = Quick_Find_Min(tmpSelectedObject2.Dist, tmpSelectedObject1.Dist)
                If tmpDist <> tmpSelectedObject2.Dist Then
                    tmpSelectedObject2 = tmpSelectedObject1
                End If
            End If
        Next r
    Next I
    'Reset index of point based on selection
    If m_SelectEntity = MultiPointType And NumberOfSolid <> 0 Then
        If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Moveable = True Then
            If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Selected Then
                'Check if last point is deselected
                If UBound(SelectedObject()) > 0 Then
                    I = 0
                    Do
                        'Find the position of selection in the array of selection
                        If SelectedObject(I).SolidID = tmpSelectedObject2.SolidID And _
                            SelectedObject(I).ShapeID = tmpSelectedObject2.ShapeID And _
                            SelectedObject(I).PointID = tmpSelectedObject2.PointID Then
                            'This happens when is deselected last point in the array
                            If I + 1 > UBound(SelectedObject()) Then
                                tmpRemoved = True
                            Else
                                'Sort the array without the selected point
                                For r = I + 1 To UBound(SelectedObject())
                                    SelectedObject(r - 1) = SelectedObject(r)
                                    tmpRemoved = True
                                Next r
                            End If
                        End If
                        I = I + 1
                    Loop Until tmpRemoved Or I = UBound(SelectedObject()) + 1
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) - 1)
                Else
                    'The array of selection contain only one point
                    ReDim SelectedObject(0)
                    tmpRemoved = True
                End If
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Selected = False
                Actions = Deselection
            Else
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Selected = True
                If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID <> 0 Then
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) + 1)
                End If
                tmpSelectedObject2.TypeID = MultiPointType
                Actions = Selection
            End If
        Else
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
        End If
    ElseIf m_SelectEntity = MultiShapeType And NumberOfSolid <> 0 Then
        If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Moveable = True Then
            If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Selected Then
                'Check if last shape is deselected
                If UBound(SelectedObject()) > 0 Then
                    I = 0
                    Do
                        'Find the position of selection in the array of selection
                        If SelectedObject(I).SolidID = tmpSelectedObject2.SolidID And _
                            SelectedObject(I).ShapeID = tmpSelectedObject2.ShapeID And _
                            SelectedObject(I).PointID = tmpSelectedObject2.PointID Then
                            'This happens when is deselected last point in the array
                            If I + 1 > UBound(SelectedObject()) Then
                                tmpRemoved = True
                            Else
                                'Sort the array without the selected point
                                For r = I + 1 To UBound(SelectedObject())
                                    SelectedObject(r - 1) = SelectedObject(r)
                                    tmpRemoved = True
                                Next r
                            End If
                        End If
                        I = I + 1
                    Loop Until tmpRemoved Or I = UBound(SelectedObject()) + 1
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) - 1)
                Else
                    'The array of selection contain only one point
                    ReDim SelectedObject(0)
                    tmpRemoved = True
                End If
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Selected = False
                Actions = Deselection
            Else
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Selected = True
                If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID <> 0 Then
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) + 1)
                End If
                tmpSelectedObject2.TypeID = MultiShapeType
                Actions = Selection
            End If
            'Reset no used index
            tmpSelectedObject2.PointID = 0
        Else
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
        End If
    ElseIf m_SelectEntity = MultiSolidType And NumberOfSolid <> 0 Then
        If mSolids.Item(tmpSelectedObject2.SolidID).Moveable = True Then
            If mSolids.Item(tmpSelectedObject2.SolidID).Selected Then
                'Check if last solid is deselected
                If UBound(SelectedObject()) > 0 Then
                    I = 0
                    
                    Do
                    
                        'Find the position of selection in the array of selection
                        If SelectedObject(I).SolidID = tmpSelectedObject2.SolidID And _
                            SelectedObject(I).ShapeID = tmpSelectedObject2.ShapeID And _
                            SelectedObject(I).PointID = tmpSelectedObject2.PointID Then
                            
                            'This happens when is deselected last point in the array
                            If I + 1 > UBound(SelectedObject()) Then
                            
                                tmpRemoved = True
                            
                            Else
                            
                                'Sort the array without the selected point
                                For r = I + 1 To UBound(SelectedObject())
                                
                                    SelectedObject(r - 1) = SelectedObject(r)
                                    tmpRemoved = True
                                    
                                Next r
                            
                            End If
                            
                        End If
                        
                        I = I + 1
                        
                    Loop Until tmpRemoved Or I = UBound(SelectedObject()) + 1
                    
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) - 1)
                
                Else
                
                    'The array of selection contain only one point
                    ReDim SelectedObject(0)
                    tmpRemoved = True
                    
                End If
                
                mSolids.Item(tmpSelectedObject2.SolidID).Selected = False
                Actions = Deselection
    
            Else
                        
                If UBound(SelectedObject()) > 0 Or SelectedObject(0).SolidID > 0 Then
                
                    ReDim Preserve SelectedObject(UBound(SelectedObject()) + 1)
                            
                End If
            
                mSolids.Item(tmpSelectedObject2.SolidID).Selected = True
                tmpSelectedObject2.TypeID = MultiSolidType
                Actions = Selection
                
            End If
            
            'Reset no used index
            tmpSelectedObject2.ShapeID = 0
            tmpSelectedObject2.PointID = 0

        Else
        
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
            
        End If
    
    ElseIf m_SelectEntity = PointType And NumberOfSolid <> 0 Then

        If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Moveable = True Then

            If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Selected Then
            
                Reset_Selection
                Actions = Deselection
                
            Else
            
                Reset_Selection
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Point(tmpSelectedObject2.PointID).Selected = True
                tmpSelectedObject2.TypeID = PointType
                Actions = Selection
                
            End If

        Else
        
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
            
        End If

    ElseIf m_SelectEntity = ShapesType And NumberOfSolid <> 0 Then
        
        If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Moveable = True Then

            If mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Selected Then
            
                Reset_Selection
                Actions = Deselection
                
            Else
            
                Reset_Selection
                mSolids.Item(tmpSelectedObject2.SolidID).Shape(tmpSelectedObject2.ShapeID).Selected = True
                tmpSelectedObject2.TypeID = ShapesType
                Actions = Selection
                
            End If
    
            'Reset no used index
            tmpSelectedObject2.PointID = 0

        Else
        
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
            
        End If

    ElseIf m_SelectEntity = SolidType And NumberOfSolid <> 0 Then
    
        If mSolids.Item(tmpSelectedObject2.SolidID).Moveable = True Then
        
            If mSolids.Item(tmpSelectedObject2.SolidID).Selected Then
            
                Reset_Selection
                Actions = Deselection
                
            Else
            
                Reset_Selection
                mSolids.Item(tmpSelectedObject2.SolidID).Selected = True
                tmpSelectedObject2.TypeID = SolidType
                Actions = Selection
                
            End If
            
            'Reset no used index
            tmpSelectedObject2.ShapeID = 0
            tmpSelectedObject2.PointID = 0
        
        Else
        
            'Cannot selected
            tmpSelectedObject2.Dist = 10 / SF
            
        End If
    
    End If

    'Check if click is in a valide zone for
    'selection.Maximal distance is 1 cm.
    If tmpSelectedObject2.Dist < 10 / SF Then

        Find_Selected = True
        
        If tmpRemoved = False Then
        
            SelectedObject(UBound(SelectedObject())) = tmpSelectedObject2
        
        End If
    Else
        Reset_Selection
        Actions = Deselection
        Find_Selected = False
        ReDim SelectedObject(0)
    End If
    'Sort selected object
    Sort_Selected SelectedObject()
    ReDim SolidsSelected(UBound(SelectedObject()))
    ReDim ShapesSelected(UBound(SelectedObject()))
    ReDim PointsSelected(UBound(SelectedObject()))
    ReDim Types(UBound(SelectedObject()))
    'Conversion of format of selected object
    For I = 0 To UBound(SelectedObject())
        SolidsSelected(I) = SelectedObject(I).SolidID
        ReDim Preserve ShapesSelected(I)
        ShapesSelected(I) = SelectedObject(I).ShapeID
        ReDim Preserve PointsSelected(I)
        PointsSelected(I) = SelectedObject(I).PointID
        ReDim Preserve Types(I)
        Types(I) = SelectedObject(I).TypeID
    Next I

    If m_AddExternalPoint = False Then
        RaiseEvent Selected(SolidsSelected(), ShapesSelected(), _
                            PointsSelected(), Types(), Actions)
    End If
End Function

Private Sub Sort_Selected(tmpSelectedobject() As FindOnScreen)
    
    Dim I As Long, M As Long, K As Long, Q As Long
    Dim tmp1() As FindOnScreen
    Dim tmp As FindOnScreen
    
    'All selected object is sorted because otherwise
    'isn't possible do a right removing function
    'Solids sort
    For I = 0 To UBound(tmpSelectedobject()) - 1
        For K = I + 1 To UBound(tmpSelectedobject())
            'Check if solid index is smallest than next solid index
            If tmpSelectedobject(I).SolidID < tmpSelectedobject(K).SolidID Then
                tmp = tmpSelectedobject(I)
                tmpSelectedobject(I) = tmpSelectedobject(K)
                tmpSelectedobject(K) = tmp
            End If
        Next K
    Next I
    ReDim tmp1(0)
    'Shapes sort
    For I = 0 To UBound(tmpSelectedobject()) - 1
        tmp1(0) = tmpSelectedobject(I)
        For K = I + 1 To UBound(tmpSelectedobject())
            If tmpSelectedobject(I).SolidID = tmpSelectedobject(K).SolidID Then
                ReDim Preserve tmp1(K - I)
                tmp1(K - I) = tmpSelectedobject(K)
            End If
        Next K
        If UBound(tmp1()) > 0 Then
            For M = 0 To UBound(tmp1()) - 1
                For Q = M + 1 To UBound(tmp1())
                    'Check if solid index is smallest than next solid index
                    If tmpSelectedobject(M).ShapeID < tmpSelectedobject(Q).ShapeID And tmpSelectedobject(M).ShapeID > 0 Then
                        tmp = tmpSelectedobject(M)
                        tmpSelectedobject(I) = tmpSelectedobject(Q)
                        tmpSelectedobject(Q) = tmp
                    End If
                Next Q
            Next M
        End If
    Next I
    'Points sort
    For I = 0 To UBound(tmpSelectedobject()) - 1
        ReDim tmp1(0)
        tmp1(0) = tmpSelectedobject(I)
        For K = I + 1 To UBound(tmpSelectedobject())
            If tmpSelectedobject(I).ShapeID = tmpSelectedobject(K).ShapeID And tmpSelectedobject(I).SolidID = tmpSelectedobject(K).SolidID Then
                ReDim Preserve tmp1(K - I)
                tmp1(K - I) = tmpSelectedobject(K)
            End If
        Next K
        If UBound(tmp1()) > 0 Then
            For M = I To I + UBound(tmp1()) - 1
                For Q = M + 1 To I + UBound(tmp1())
                    'Check if solid index is smallest than next solid index
                    If tmpSelectedobject(M).PointID < tmpSelectedobject(Q).PointID And tmpSelectedobject(M).PointID > 0 Then
                        tmp = tmpSelectedobject(M)
                        tmpSelectedobject(M) = tmpSelectedobject(Q)
                        tmpSelectedobject(Q) = tmp
                    End If
                Next Q
            Next M
        End If
    Next I
End Sub

Public Sub Reset_Selection()
'Deselect all figures rappresented

    'Declarations
    Dim I As Long
    
    For I = 1 To NumberOfSolid
        mSolids.Item(I).Selected = False
    Next I
    ReDim SelectedObject(0)
End Sub

